#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define mp std::make_pair

std::mt19937 myRandom(clock());

struct node {
    int val, prior;

    node *l, *r;

    node() : val(0), prior(myRandom()), l(nullptr), r(nullptr) {}
    node(int val) : val(val), prior(myRandom()), l(nullptr), r(nullptr) {}
};

typedef node * pnode;

void walk(const pnode &now) {
    if(now == nullptr) return;
    walk(now->l);
    std::cout << now << ' ' << now->val << ' ' << now->prior << ' ' << now->l << ' ' << now->r << '\n';
    walk(now->r);
}

void killTree(pnode &now) {
    if(now == nullptr) return;
    killTree(now->l), killTree(now->r);
    delete now;
}

pnode merge(pnode &left, pnode &right) {
    if(left == nullptr) return right;
    if(right == nullptr) return left;

    if(left->prior > right->prior) std::swap(left, right);
    if(left->val < right->val) {
        left->r = merge(left->r, right);
        return left;
    }
    else {
        left->l = merge(left->l, right);
        return left;
    }
}

std::pair<pnode, pnode> split(pnode &root, int key) {
    if(root == nullptr) return mp(nullptr, nullptr);

    if(root->val > key) {
        auto res = split(root->l, key);
        root->r = merge(root->r, res.second);
        return mp(root->l, root->r);
    }
    else if(key >= root->val) {
        auto res = split(root->r, key);
        root->l = merge(root->l, res.first);
        return mp(root->l, root->r);
    }
}

int main() {
    int t;
    std::cin >> t;
    while(t--) {
        int a, b;
        std::cin >> a >> b;
        std::cout << a * b << '\n';
    }
}
