import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {

    static int iinf = (int) 1e9;
    static long inf = (long) 1e18;

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(System.in);
        PrintWriter pw = new PrintWriter(System.out);

        int t = sc.nextInt();
        for (int i = 0; i < t; i++) {
            long a = sc.nextLong();
            long b = sc.nextLong();
            pw.println(a * b);
        }

        pw.close();
    }

    static long gcd(long a, long b) {
        if (a == 0 || b == 0) return a + b;
        return gcd(b % a, a);
    }

    static long fact(long a) {
        if (a == 0) return 1;
        return fact(a - 1) * a;
    }

    static long pow(long a, long n, long pow) {
        long res = 1;
        while (n > 0) {
            res = n % 2 == 1 ? (res * a) % pow : res;
            a = (a * a) % pow;
            n /= 2;
        }
        return res;
    }
}

class Scanner {
    static BufferedReader br;
    static StringTokenizer st = new StringTokenizer("");

    public Scanner(InputStream inputStream) {
        br = new BufferedReader(new InputStreamReader(inputStream));
    }

    public String next() throws IOException {
        while (!st.hasMoreTokens())
            st = new StringTokenizer(br.readLine());
        return st.nextToken();
    }

    public long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(next());
    }
}
