#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ALL(x) x.begin(), x.end()
#define RALL(x) x.rbegin(), x.rend()

typedef long double ld;
typedef vector<int> VI;
typedef vector<VI> VVI;
typedef pair<int, int> PII;

struct SegTree
{
    VI t;
    int size;

    void init (int n)
    {
        size = 1;
        while (size < n) {
            size *= 2;
        }
        t.assign(2*size - 1, 0);
    }

    void build (const VI& a, int x, int lx, int rx) {
        if (rx == lx + 1) {
            if (lx < a.size()) {
                t[x] = a[lx];
            }
        } else {
            int m = (lx + rx) / 2;
            build(a, 2*x + 1, lx, m);
            build(a, 2*x + 2, m, rx);
            t[x] = t[2*x+1] + t[2*x + 2];
        }
    }

    void build (const VI& a)
    {
        init(a.size());
        build(a, 0, 0, size);
    }

    void set (int i, int v, int x, int lx, int rx)
    {
        if (rx == lx + 1) {
            t[x] = v;
        } else {
            int m = (lx + rx) / 2;
            if (i < m) {
                set(i, v, 2*x + 1, lx, m);
            } else {
                set(i, v, 2*x + 2, m, rx);
            }
            t[x] = t[2*x+1] + t[2*x + 2];
        }
    }

    void set (int i, int v)
    {
        set(i, v, 0, 0, size);
    }

    int get (int l, int r, int x, int lx, int rx)
    {
        if (lx >= r || rx <= l) {
            return 0;
        }

        if (lx >= l && rx <= r) {
            return t[x];
        }

        int m = (lx + rx) / 2;
        int s1 = get(l, r, 2*x + 1, lx, m);
        int s2 = get(l, r, 2*x + 2, m, rx);
        return s1 + s2;
    }

    int get (int l, int r)
    {
        get(l, r, 0, 0, size);
    }
};

signed main ()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int Q;
    cin >> Q;
    //Q = 1;
    while (Q--) {
        int a, b;
        cin >> a >> b;

        cout << a*b << endl;
    }

    return 0;
}