#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cmath>
#include <queue>
#include <random>
#include <cstdio>
#include <string>
#include <ctime>

#define pb push_back
#define rs resize
#define mp make_pair

typedef long long ll;

using namespace std;

const int di[4] = {-1, 0, 1, 0};
const int dj[4] = {0, 1, 0, -1};
const int INF = 2e9;
const ll INF2 = 2e18;

ostream &operator << (ostream &out, vector <int> &v){
	for(int i = 0; i < v.size(); i++){
		out<<v[i]<<" ";
	}
	out<<"\n";
	return out;
}

istream &operator >> (istream &in, vector <int> &v){
	for(int i = 0; i < v.size(); i++){
		in>>v[i];
	}
	return in;
}

ostream &operator << (ostream &out, vector <ll> &v){
	for(int i = 0; i < v.size(); i++){
		out<<v[i]<<" ";
	}
	out<<"\n";
	return out;
}

istream &operator >> (istream &in, vector <ll> &v){
	for(int i = 0; i < v.size(); i++){
		in>>v[i];
	}
	return in;
}

ostream &operator << (ostream &out, vector <vector <int> > &v){
	for(int i = 0; i < v.size(); i++){
		for(int j = 0; j < v[i].size(); j++){
			out<<v[i]<<" ";
		}
		out<<"\n";
	}
	out<<"\n";
	return out;
}

ll dijkstra(int start, int end, int n, vector <vector <pair <int, int> > > &g){
	vector <ll> dist(n, INF2);
	set <pair <ll, int> > q;
	dist[start] = 0;
	q.insert({0, start});
	while(q.size()){
		int v = (*q.begin()).second;
		q.erase(q.begin());
		for(int i = 0; i < g[v].size(); i++){
			int u = g[v][i].first, cost = g[v][i].second;
			if(dist[u] > dist[v] + cost){
				q.erase({dist[u], u});
				dist[u] = dist[v] + cost;
				q.insert({dist[u], u});
			}
		}
	}
	return dist[end];
}

int main(){
	ll t;
	cin>>t;
	while(t--){
		ll a, b;
		cin>>a>>b;
		ll ab = a * (b + 1) + b * (a + 1);
		ll ans = (b + a + b + (a - 1) * (b - 1) + (a - 1));
		cout<<ab - ans<<"\n";
	}
	return 0;
}
