#ifdef LOCAL
#include "debug.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x)
#endif

#define int ll

using namespace std;

typedef long long ll;
typedef long double ld;
#define sz(x) int(x.size())

template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

#ifdef LOCAL
mt19937 rng(1000 - 7);
#else
mt19937 rng(time(0));
#endif

const int N = 1e5 + 10;
const int MOD = 1e9 + 7;
const ld eps = 5e-8;

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    int q;
    cin >> q;

    while (q--) {
        int n;
        cin >> n;

        vector <int> a(n);
        for (int& x : a) {
            cin >> x;
        }

        if (n == 1) {
            cout << "0\n";
            continue;
        }

        set <int> s, t;
        for (int i = 1; i < n; i++) {
            if (a[i] > a[i - 1]) {
                s.insert(a[i] - a[i - 1]);
            } else {
                t.insert(a[i - 1] - a[i]);
            }
        }

        if (sz(s) > 1 || sz(t) > 1) {
            cout << "-1\n";
        } else if (sz(s) == 0 || sz(t) == 0) {
            cout << "0\n";
        } else {
            int m = *s.begin() + *t.begin();

            bool flag = true;
            for (int i = 0; i < n; i++) {
                if (a[i] >= m) {
                    flag = false;
                }
            }
       
            if (flag) {
                cout << m << " " << *s.begin() << "\n";
            } else {
                cout << "-1\n";
            }
        }
    }

    return 0;
}
