#include <iostream>
#include <random>

#include <cmath>

#include <algorithm>

#include <vector>
#include <set>

using namespace std;

typedef long long ll;

ll inf = 1e18;

bool is_good(vector<ll>&a, ll c, ll m) {
	for (ll i = 1; i < a.size(); i++) {
		if ((a[i - 1] + c) % m != a[i]) {
			return false;
		}
	}

	return true;
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	ll t; cin >> t;
	while (t--) {
		ll n; cin >> n;
		vector<ll> a(n);
		ll max_a = 0;
		for (auto &c : a) {
			cin >> c;
			max_a = max(max_a, c);
		}

		if (is_good(a, a[1] - a[0], inf)) {
			cout << 0 << '\n';
		}
		else {
			set<ll> d;
			for (ll i = 1; i < n; i++) {
				d.insert(a[i] - a[i - 1]);
			}

			ll m = *d.rbegin() - *d.begin();
			if (m <= max_a) {
				cout << -1 << '\n';
			}
			else if (is_good(a, a[1] - a[0], m) && a[1] - a[0] >= 0) {
				cout << m << ' ' << a[1] - a[0] << '\n';
			}
			else if (is_good(a, a[1] - a[0] + m, m) && a[1] - a[0] < m) {
				cout << m << ' ' << a[1] - a[0] + m << '\n';
			}
			else {
				cout << -1 << '\n';
			}
		}
	}

	return 0;
}
