#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#include <cmath>
#include <assert.h>
#include <queue>
#include <cstring>
#include <bitset>
#include <random>

using namespace std;

template<typename T> void uin(T &a, T b) {
    if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
    if (b > a) a = b;
}

#define int long long
#define next next288
#define left left228
#define right right228

bool check(vector<int> a, int n, int m, int c, int s) {
    s %= m;
    for (int i = 0; i < n; ++i) {
        if (a[i] != s) {
            return false;
        }
        s = (s + c) % m;
    }
    return true;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while(t--) {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        if (n == 1) {
            cout << 0 << '\n';
            continue;
        }

        int c = -1, m = -1;
        bool inc = true;
        bool okey = true;

        for (int i = 0; i < n - 1; ++i) {
            if (a[i] < a[i + 1]) {
                if (c != -1 && a[i + 1] - a[i] != c) {
                    okey = false;
                }
                c = a[i + 1] - a[i];
            }
            if (a[i] >= a[i + 1]) {
                inc = false;
            }
        }

        if (inc == true) {
            // c is fixed, m -> inf
            if (okey) {
                cout << 0 << '\n';
            } else {
                cout << -1 << '\n';
            }
            continue;
        }
        if (c != -1) {
            for (int i = 0; i < n - 1; ++i) {
                if (a[i] >= a[i + 1]) {
                    m = a[i] + c - a[i + 1];
                }
            }
            if (m > 0 && c < m && check(a, n, m, c, a[0])) {
                cout << m << " " << c << endl;
            } else {
                cout << -1 << '\n';
            }
            continue;
        }

        bool equal = true;

        for (int i = 0; i < n - 1; ++i) {
            if (a[i] != a[i + 1]) {
                equal = false;
            }
        }

        if (equal) {
            // c = 0, m = inf
            cout << 0 << '\n';
            continue;
        }

        set<int> SET;
        for (int i = 0; i < n - 1; ++i) {
            SET.insert(a[i + 1] - a[i]);
        }
        if (SET.size() != 1) {
            cout << -1 << '\n';
            continue;
        }
        int delta = *SET.begin(); // c - m = DELTA
        if (delta < 0) {
            cout << 0 << endl;
        } else {
            cout << -1 << endl;
        }
    }
    return 0;
}