#ifdef FAIRLY_LOCAL
#define _GLIBCXX_DEBUG
#endif

#include <iostream>
#include <vector>
#include <unordered_map>
using namespace std;

int main() {
#ifdef FAIRLY_LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;

    cin >> t;
    while (t --> 0) {
        int n;
        vector<int> a;

        cin >> n;
        a.resize(n);
        int max_elem = 0;
        for (int &elem : a) {
            cin >> elem;
            max_elem = max(max_elem, elem);
        }

        if (n == 1) {
            cout << 0 << '\n';
            continue;
        }

        unordered_map<int, int> dif;
        for (int i = 0; i < n - 1; ++i) {
            dif[a[i + 1] - a[i]]++;
        }

        if (dif.size() > 2) {
            cout << -1 << '\n';
        } else if (dif.size() == 1 && dif.begin()->first >= 0) {
            cout << 0 << '\n';
        } else if (dif.size() == 1 && dif.begin()->first < 0) {
            cout << 0 << '\n';
        } else {
            bool pos = true;
            int pc, nc;
            for (auto p : dif) {
                if (p.first < 0) {
                    pos &= false;
                    nc = p.first;
                } else {
                    pc = p.first;
                }
            }

            if (pos) {
                cout << -1 << '\n';
                continue;
            }

            int m = pc - nc;

            bool chk = true;
            for (int i = 0; i < n - 1; ++i) {
                if (a[i + 1] != (a[i] + pc) % m) {
                    chk &= false;
                }
            }

            if (chk && m > max_elem) {
                cout << m << ' ' << pc << '\n';
            } else {
                cout << -1 << '\n';
            }
        }
    }
    return 0;
}
