/*#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define mp std::make_pair
#define int long long

std::mt19937 myRandom(clock());

template<class T>
T mx(T &l, const T& r) {
    if(r > l) l = r;
    return l;
}

template<class T>
T mn(T &l, const T& r) {
    if(r < l) l = r;
    return l;
}

struct node {
    int val, prior;

    node *l, *r;

    node() : val(0), prior(myRandom()), l(nullptr), r(nullptr) {}
    node(int val) : val(val), prior(myRandom()), l(nullptr), r(nullptr) {}
};

typedef node * pnode;

void walk(const pnode &now) {
    if(now == nullptr) return;
    walk(now->l);
    std::cout << now << ' ' << now->val << ' ' << now->prior << ' ' << now->l << ' ' << now->r << '\n';
    walk(now->r);
}

void killTree(pnode &now) {
    if(now == nullptr) return;
    killTree(now->l), killTree(now->r);
    delete now;
}

pnode merge(pnode &left, pnode &right) {
    if(left == nullptr) return right;
    if(right == nullptr) return left;

    if(left->prior > right->prior) std::swap(left, right);
    if(left->val < right->val) {
        left->r = merge(left->r, right);
        return left;
    }
    else {
        left->l = merge(left->l, right);
        return left;
    }
}

std::pair<pnode, pnode> split(pnode &root, int key) {
    if(root == nullptr) return mp(nullptr, nullptr);

    if(root->val > key) {
        auto res = split(root->l, key);
        root->r = merge(root->r, res.second);
        return mp(root->l, root->r);
    }
    else if(key >= root->val) {
        auto res = split(root->r, key);
        root->l = merge(root->l, res.first);
        return mp(root->l, root->r);
    }
}

int32_t main() {
    std::ios::sync_with_stdio(0), std::cin.tie(0);

    int t;
    std::cin >> t;
    while(t--) {
        int n, m;
        std::cin >> n >> m;
        std::pair<std::set<int>, int> friends[n];
        for(int i = 0; i < n; i++) friends[i].first.clear(), friends[i].second = i;
        int picked[m];
        int cnt[n];
        int canForDay[m];
        std::vector<int> day2person[m];

        memset(canForDay, 0, sizeof(canForDay));
        memset(cnt, 0, sizeof(cnt));
        memset(picked, -1, sizeof(picked));
        for(auto &i : day2person) i.clear();

        for(int i = 0; i < m; i++) {
            int now;
            std::cin >> now;
            canForDay[i] = now;
            for(int j = 0; j < now; j++) {
                int fr;
                std::cin >> fr;
                --fr;
                day2person[i].push_back(fr);
                friends[fr].first.insert(i);
            }
        }

        std::sort(friends, friends + n, [&](const std::pair<std::vector<int>, int> &a, const std::pair<std::vector<int>, int> &b){ return a.first.size() < b.first.size(); });

        for(int i = 0; i < n; i++) {
            if(friends[i].friends.size() > (m + 1) / 2) continue;
            for(auto &day : friends[i].first) {
                if(picked[day] == -1 && cnt[friends[i].second] + 1 <= (m + 1) / 2) {
                    picked[day] = friends[i].second;
                    
                    for(auto &person : day2person[day]) day2person[person].erase(day);
                    
                    cnt[friends[i].second]++;
                }
            }
        }

        std::sort(friends, friends + n, [&](const std::pair<std::vector<int>, int> &a, const std::pair<std::vector<int>, int> &b){ return a.first.size() < b.first.size(); });

        if(*std::max_element(cnt, cnt + n) > (m + 1) / 2 || *std::min_element(picked, picked + m) == -1) {
            std::cout << "NO\n";
            continue;
        }

        std::cout << "YES\n";
        for(auto &i : picked) std::cout << i + 1 << ' ';
        std::cout << '\n';
    }
}
*/

#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define mp std::make_pair
#define int long long

std::mt19937 myRandom(clock());

template<class T>
T mx(T &l, const T& r) {
    if(r > l) l = r;
    return l;
}

template<class T>
T mn(T &l, const T& r) {
    if(r < l) l = r;
    return l;
}

struct node {
    int val, prior;

    node *l, *r;

    node() : val(0), prior(myRandom()), l(nullptr), r(nullptr) {}
    node(int val) : val(val), prior(myRandom()), l(nullptr), r(nullptr) {}
};

typedef node * pnode;

void walk(const pnode &now) {
    if(now == nullptr) return;
    walk(now->l);
    std::cout << now << ' ' << now->val << ' ' << now->prior << ' ' << now->l << ' ' << now->r << '\n';
    walk(now->r);
}

void killTree(pnode &now) {
    if(now == nullptr) return;
    killTree(now->l), killTree(now->r);
    delete now;
}

pnode merge(pnode &left, pnode &right) {
    if(left == nullptr) return right;
    if(right == nullptr) return left;

    if(left->prior > right->prior) std::swap(left, right);
    if(left->val < right->val) {
        left->r = merge(left->r, right);
        return left;
    }
    else {
        left->l = merge(left->l, right);
        return left;
    }
}

std::pair<pnode, pnode> split(pnode &root, int key) {
    if(root == nullptr) return mp(nullptr, nullptr);

    if(root->val > key) {
        auto res = split(root->l, key);
        root->r = merge(root->r, res.second);
        return mp(root->l, root->r);
    }
    else if(key >= root->val) {
        auto res = split(root->r, key);
        root->l = merge(root->l, res.first);
        return mp(root->l, root->r);
    }
}

int32_t main() {
    std::ios::sync_with_stdio(0), std::cin.tie(0);

    int t;
    std::cin >> t;
    while(t--) {
        int n;
        std::cin >> n;
        int a[n];
        for(auto &i : a) std::cin >> i;

        int c = -1;
        bool die = false;
        bool wasLower = false;

        for(int i = 1; i < n; i++) {
            if(a[i] >= a[i - 1]) {
                if(c == -1) c = a[i] - a[i - 1];
                else if(a[i] - a[i - 1] != c) die = true;
            }
            else wasLower = true;
        }

        if(die) {
            std::cout << -1 << '\n';
            continue;
        }

        if(c != -1) {
            if(!wasLower) {
                std::cout << 0 << '\n';
                continue;
            }
            int m = -1;
            int maxi = *std::max_element(a, a + n);
            for(int i = 0; i < n - 1; i++) {
                if(a[i] > a[i + 1]) {
                    int newM = a[i] + c - a[i + 1];
                    if(m == -1 || m == newM) m = newM;
                    else die = true;
                }
            }

            if(m == -1) die = true;
            for(int i = 0; i < n; i++) if(a[i] >= m) die = true;
            for(int i = 1; i < n; i++) die |= (a[i - 1] + c) % m != a[i];

            if(die) {
                std::cout << -1 << '\n';
                continue;
            }
            
            std::cout << m << ' ' << c << '\n';
            continue;
        }

        for(int i = 0; i + 2 < n; i++) if((a[i] + a[i + 2]) != 2 * a[i + 1]) die = true;
        for(int i = 0; i < n - 1; i++) {
            int nowC = a[i + 1] - a[i];
            if(c == -1 || c == nowC) c = nowC;
            else die = true;
        }

        if(die) std::cout << -1 << '\n';
        else std::cout << 0 << '\n';
    }
}
