//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse42,avx,bmi,popcnt")
//#define _GLIBCXX_DEBUG
#include <iostream>
#include <cstdio>
#include <climits>
#include <cmath>
#include <vector>
#include <array>
#include <algorithm>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

struct point
{
	int64_t x, y;
	point operator + (const point& rhs) const
	{
		return {x+rhs.x, y+rhs.y};
	}
	point operator - (const point& rhs) const
	{
		return {x-rhs.x, y-rhs.y};
	}
	int64_t operator * (const point& rhs) const
	{
		return x*rhs.x + y*rhs.y;
	}
	int64_t operator % (const point& rhs) const
	{
		return x*rhs.y - y*rhs.x;
	}
	double dist() const
	{
		return std::hypot(x, y);
	}
};
int64_t gcd(int64_t a, int64_t b)
{
	if(a < 0) a = -a;
	if(b < 0) b = -b;
	if(a == 0 || b == 0) return a + b;
	return gcd(b, a%b);
}
int main()
{
	int t; std::cin >> t;
	while(t --> 0)
	{
		int n; std::cin >> n;
		std::vector<int64_t> a(n);
		for(int64_t& x : a) scanf("%lld", &x);
		int64_t s = a[0];
		int64_t c = a[1] - a[0]; //may be negative
		std::vector<int64_t> a2(n);
		a2[0] = s;
		for(int i = 1; i < n; i++)
			a2[i] = a2[i-1] + c;
		//for(int64_t el : a2) printf("%lld ", el); printf("\n");
		//get gcd of all differences
		int64_t g = 0;
		for(int i = 0; i < n; i++)
			g = gcd(g, a2[i]- a[i]);
		if(g == 0) { printf("0\n"); continue; }
		std::vector<int64_t> a3(n);
		a3[0] = (s + g) % g;
		for(int i = 1; i < n; i++)
			a3[i] = (a3[i-1] + c + g) % g;
		//for(int64_t el : a3) printf("%lld ", el); printf("\n");
		bool ok = true;
		for(int i = 0; i < n; i++)
			if(a3[i] != a[i]) ok = false;
		if(!ok) printf("-1\n");
		else printf("%lld %lld\n", g, (c + g) % g);
	}
}
