#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>
#include <cstring>
#include <sstream>
#include <functional>
#include <unordered_set>
#include <array>
#include <deque>
#include <chrono>
#include <random>

#define err(x) {cerr << "["#x"]  " << (x) << '\n';}
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << (___) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << ((x)[___]) << ", "; cerr << "]\n";}
#define errf() {cerr << "\n\n";}
#define sq(x) ((x)*(x))

using ll = long long;
using ld = long double;
using ull = unsigned long long;

using namespace std;

//mt19937 rng(random_device());

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

// ::::::::::::::::::::::::::::::::::::;

void solve() {
    int n;
    cin >> n;

    vector<ll> a(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];

    if (n <= 2) {
        cout << "0\n";
        return;
    }

    ll d = -1;
    for (int i = 1; i < n; ++i) {
        if (a[i] >= a[i - 1]) {
            if (d == -1)
                d = a[i] - a[i - 1];
            else {
                if (d != a[i] - a[i - 1]) {
                    cout << "-1\n";
                    return;
                }
            }
        }
    }

    if (d == -1) {
        d = a[1] - a[0];
        for (int i = 1; i < n; ++i) {
            if (a[i] - a[i - 1] != d) {
                cout << "-1\n";
                return;
            }
        }
        cout << "0\n";
    }
    else {
        ll m = -1;
        for (int i = 1; i < n; ++i) {
            if (a[i] < a[i - 1]) {
                m = a[i - 1] + d - a[i];
            }
        }
        if (m == -1) {
            cout << "0\n";
            return;
        }

        if (m <= a[0]) {
            cout << "-1\n";
            return;
        }
        for (int i = 1; i < n; ++i) {
            if ((a[i - 1] + d) % m != a[i]) {
                cout << "-1\n";
                return;
            }
        }
        cout << m << " " << d << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();

    return 0;
}

