#include <iostream>
#include <cmath>
#include <chrono>
#include <vector>
#include <bitset>
#include <string>

using namespace std;

template<typename T>
string to_string(vector<T> &a) {
    string res = "{";
    bool first = 1;
    for (auto &i : a) {
        if (!first) {
            res += ", ";
        }
        first = 0;
        res += to_string(i);
    }
    res += "}";
    return res;
}

void debug_out() {
    cerr << endl;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << ' ' << to_string(H); 
    debug_out(T...);
}

typedef long long ll;
typedef long double ld;

#define int long long
#define x first
#define y second
#define all(a) a.begin(), a.end()
#define sz(a) (int) a.size()

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...) 22888
#endif

const int N = 1e5 + 5;
const int INF = 1e16 + 7;
const ld EPS = 1e-12;

// struct segtree {

//     struct node {
//         int v, p;
//     };

//     int s;
//     vector<node> tree;

//     segtree(int n) {
//         s = 1;
//         while (s < n) {
//             s *= 2;
//         }
//         tree.resize(2 * s + 1);
//     }

//     node combine(node a, node b) {
//         return {
//             a.v + b.v,
//             0
//         };
//     }

//     void push(int x, int lx, int rx) {
//         if (lx + 1 == rx || tree[x].p == 0) return;
//         int p = tree[x].p;
//         tree[2 * x + 1].p += p;
//         tree[2 * x + 2].p += p;
//         tree[2 * x + 1].v += p;
//         tree[2 * x + 2].v += p;
//         tree[x].p = 0;
//     }

//     void build(vector<int> &a, int x, int lx, int rx) {
//         if (lx + 1 == rx) {
//             if (lx < sz(a)) {
//                 tree[x].v = a[lx];
//             }
//             return;
//         }
//         int m = (lx + rx) / 2;
//         build(a, 2 * x + 1, lx, m);
//         build(a, 2 * x + 2, m, rx);
//         tree[x] = combine(tree[2 * x + 1], tree[2 * x + 2]);
//     }

//     void set(int l, int r, int v, int x, int lx, int rx) {

//     }
// };

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    bool found = 0, cond = 1;
    int c;
    for (int i = 1; i < n; i++) {
        if (a[i] >= a[i - 1]) {
            if (found) {
                if (c != a[i] - a[i - 1]) {
                    cond = 0;
                }
            }
            c = a[i] - a[i - 1];
            found = 1;
        }
    }
    bool found1 = 0;
    int m;
    for (int i = 1; i < n; i++) {
        if (a[i] < a[i - 1]) {
            if (found1) {
                if (m != a[i - 1] + c - a[i]) {
                    cond = 0;
                }
            }
            found1 = 1;
            m = a[i - 1] + c - a[i];
        }
    }
    for (int i = 0; i < n; i++) {
        cond &= m > a[i];
    }

    bool zero = 1;
    for (int i = 2; i < n; i++) {
        zero &= a[i] - a[i - 1] == a[i - 1] - a[i - 2];
    }
    if (zero) {
        cout << 0 << '\n';
    } else if (cond && found && found1) {
        cout << m << ' ' << c << '\n';
    } else {
        cout << -1 << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int tests = 1;
    cin >> tests;

    while (tests-- > 0) {
        solve();
    }
}