#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>

#ifndef DEBUG
#define endl '\n'
#endif

using namespace std;
typedef long long ll;
typedef long double ld;

constexpr ll inf = 1e18;

void solve();

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);
  cerr.setf(ios::fixed);
  cerr.precision(5);
  ll start = clock();
  ll case_count = 1;
  cin >> case_count;
  while (case_count--) solve();
  cerr << ld(clock() - start) / CLOCKS_PER_SEC << endl;
}

// ---------


void solve() {
  ll n;
  cin >> n;
  vector<ll> a(n);
  ll mx = 0;
  ll mn = 0;
  ll steppos = inf;
  ll stepneg = -inf;
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    if (a[i] > a[mx]) {
      mx = i;
    }
    if (a[i] < a[mn]) {
      mn = i;
    }
    if (i > 0) {
      ll curstep = a[i] - a[i - 1];
      if (curstep >= 0) {
        if (steppos == inf) {
          steppos = curstep;
        }
      } else {
        if (stepneg == -inf) {
          stepneg = curstep;
        }
      }
    }
  }
  ll m = steppos - stepneg;
  if (m <= a[mx]) {
    cout << -1 << endl;
    return;
  }
  ll c = a[0];
  for (int i = 1; i < n; ++i) {
    c = (c + steppos) % m;
    if (c != a[i]) {
      cout << -1 << endl;
      return;
    }
  }
  if (m >= inf) {
    cout << 0 << endl;
    return;
  }
  cout << m << ' ' << steppos << endl;
}