/*
 * PRAGMA MORGEN
 * PRAGMA KADILLAK
 * PRAGMA SLAVA MARLOW
 * PRAGMA AVTOMAT
 * PRAGMA MERIN
 * PRAGMA KRISTAL
 * PRAGMA MOET
 * PRAGMA YUNG HEFNER
 */

#include <bits/stdc++.h>

#define pll pair<ll, ll>
#define x first
#define y second

#define ff first
#define ss second

/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,tune=native")
/**/
using namespace std;

typedef long long int ll;

mt19937 gen(1337);

ll n, m;

struct dt{
    dt *l, *r;
    ll y;
    ll sz;
    ll val;

    dt(){
        y = gen();
        sz = 1;
        l = r = nullptr;
    }

    dt(ll v){
        y = gen();
        sz = 1;
        l = r = nullptr;
        val = v;
    }
};

ll get_sz(dt * a){
    if(a == nullptr) return 0;
    return a->sz;
}

dt* merge(dt *l, dt *r){
    if(l == nullptr) return r;
    if(r == nullptr) return l;

    if(l->y > r->y){
        dt *a = merge(l->r, r);
        l->r = a;
        l->sz = get_sz(l->l) + 1 + get_sz(l->r);
        return l;
    }else {
        dt *a = merge(l, r->l);
        r->l = a;
        r->sz = get_sz(r->l) + 1 + get_sz(r->r);
        return r;
    }
}

pair<dt*, dt*> split(dt *a, ll i){
    if (a == nullptr) return {nullptr, nullptr};
    ll ind = get_sz(a->l);
    if(ind < i){
        pair<dt *, dt*> kek = split(a->r, i - ind - 1);
        a->r = kek.first;
        a->sz = get_sz(a->l) + 1 + get_sz(a->r);
        return {a, kek.second};
    }else{
        pair<dt*, dt*> kek = split(a->l, i);
        a->l = kek.second;
        a->sz = get_sz(a->l) + 1 + get_sz(a->r);
        return {kek.first, a};
    }
}

const ll INF = 1e12;

void solve(){
    ll t;
    cin >> t;
    for (int aafd = 0; aafd < t; ++aafd) {
        cin >> n;
        vector<ll> a(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i];
        }
        bool eq = true;
        for (int i = 0; i + 1 < n; ++i) {
            if(a[i] != a[i + 1]) eq = false;
        }
        if(eq){
            //c = m * x
            //xmin = 1
            //m = c
            cout << "0\n";
            continue;
        }

        bool broken = false;
        ll pldiff = -INF;
        ll mndiff = -INF;
        bool zero = false;
        for (int i = 0; i + 1 < n; ++i) {
            if(a[i + 1] - a[i] != 0 && zero){
                broken = true;
                break;
            }
            if(a[i + 1] - a[i] > 0){
                if(pldiff == -INF) pldiff = a[i + 1] - a[i];
                else if(pldiff != a[i + 1] - a[i]){
                    broken = true;
                    break;
                }
            }else if(a[i + 1] - a[i] < 0){
                if(mndiff == -INF) mndiff = a[i + 1] - a[i];
                else if(mndiff != a[i + 1] - a[i]){
                    broken = true;
                    break;
                }
            }else{
                zero = true;
                if(pldiff != -INF || mndiff != -INF){
                    broken = true;
                    break;
                }
            }
        }

        ll period = pldiff - mndiff;
        if(broken){
            cout << "-1\n";
        }else if(period == 0){
            cout << period << "\n";
        }else{
            if(pldiff == -INF || mndiff == -INF){
                cout << "0\n";
                continue;
            }
            ll c = (a[1] - a[0] + period) % period;

            ll cu = a[0];

            if(a[0] > period) broken = true;
            for (int i = 1; i < n; ++i) {
                if(a[i] != (cu + c) % period){
                    broken = true;
                    break;
                }
                cu = a[i];
            }
            if(broken) cout << "-1\n";
            else cout << period << " " << c << "\n";
        }
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    /*
    freopen("input.txt", "r", stdin);
    /**/
    solve();
}