﻿#define ll long long

#include<iostream>
#include<iomanip>
#include<cmath>
#include<algorithm>
#include<map>
#include<vector>
#include<set>
#include<string>

using namespace std;

struct el {
    ll a = 0, b = 0;
    el(ll v1 = 0, ll v2 = 0) {
        a = v1;
        b = v2;
    }
    const bool operator <(const el& e) const {
        return tie(a) < tie(e.a);
    }
};

/////////////////// SEGMENT_TREE //////////////////////
/*

void build(vector<ll> &tree, vector<ll> &a, ll now, ll l, ll r) {
    if (l == r) {
        tree[now] = a[l];
        return;
    }
    ll mid = (r + l) / 2;
    build(tree, a, now * 2 + 1, l, mid);
    build(tree, a, now * 2 + 2, mid + 1, r);
    tree[now] = max(tree[now * 2 + 1], tree[now * 2 + 2]);
}

void change(vector<ll>& tree, ll now, ll l, ll r, ll pos, ll x) {
    if (l == r) {
        tree[l] = x;
        return;
    }
    ll mid = (l + r) / 2;
    if (pos <= mid) {
        change(tree, now * 2 + 1, l, mid, pos, x);
    }
    else {
        change(tree, now * 2 + 2, mid + 1, r, pos, x);
    }
    tree[now] = max(tree[now * 2 + 1], tree[now * 2 + 2]);
}

ll qw(vector<ll>& tree, ll now, ll l, ll r, ll ql, ll qr) {
    ql = max(ql, l);
    qr = min(qr, r);
    if (ql > qr) {
        return -1e9;
    }
    if (l == ql && r == qr) {
        return tree[now];
    }
    ll mid = (l + r) / 2;
    return max(
        qw(tree, now * 2 + 1, l, mid, ql, qr),
        qw(tree, now * 2 + 2, mid + 1, r, ql, qr));
}

*/
/////////////////// SEGMENT_TREE //////////////////////

void true_main() {
    ll n;
    cin >> n;
    ll mx = 0;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        mx = max(mx, a[i]);
    }
    ll c = -1, d = -1;
    for (int i = 1; i < n; i++) {
        if (a[i] == a[i - 1] && (c > 0 || d > 0)) {
            cout << -1;
            return;
        }
        if (a[i] - a[i - 1] > 0) {
            ll c1 = a[i] - a[i - 1];
            if (c == -1) {
                c = c1;
            }
            else if (c != c1) {
                cout << -1;
                return;
            }
        }
        else {
            ll d1 = a[i - 1] - a[i];
            if (d == -1) {
                d = d1;
            }
            else if (d != d1) {
                cout << -1;
                return;
            }
        }
    }
    if (d == -1) {
        cout << 0;
        return;
    }
    if (c == -1) {
        cout << 0;
        return;
    }
    if (c == d && c == 0) {
        cout << 0;
        return;
    }
    ll ans = c + d;
    if (ans <= mx) {
        cout << -1;
        return;
    }
    cout << ans << " " << c;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    // freopen("", "r", stdin);
    // freopen("", "w", stdout);

    ll t = 1;
    cin >> t;
    
    while (t--) {
        true_main();
        cout << "\n";
    }
}