#include<iostream>
#include<vector>
#include<set>
#include<algorithm>
#include<map>
#include<unordered_map>
#include<fstream>
#include<queue>
#include<deque>
#include<cmath>

using namespace std;

typedef long long ll;
typedef vector<ll>vll;
typedef vector<vll>vvl;

typedef pair<ll, ll>pll;
typedef vector<pll>vpl;
typedef vector<vpl>vvp;

typedef pair<int, int>pi;
typedef vector<pi>vpi;

typedef vector<int>vi;
typedef vector<bool>vb;

#define forn(i, n) for(int i = 0; i < n; i++)
#define forab(i, a, b) for (int i = a; i < b; i++)
#define in ll_input()

ll ll_input() { ll t; cin >> t; return t; }

void solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int t = in;
	while (t--)
		solve();
}


//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////

ll binpow(ll n, ll p, ll mod = 1000000007) {
	if (!p)
		return 1;
	if (p % 2)
		return n * binpow(n, p - 1) % mod;
	else
		return binpow(n * n % mod, p / 2);
}

vll prefsums(vll& v) {
	vll res(v.size());
	res[0] = v[0];
	forab(i, 1, v.size())
		res[i] = res[i - 1] + v[i];
	return res;
}

vll sufsums(vll& v) {
	vll res(v.size());
	res.back() = v.back();
	forab(i, 1, v.size())
		res[v.size() - i - 1] = res[v.size() - i] + v[v.size() - i - 1];
	return res;
}

ll get_hash(string s, int p) {
	ll hash = 0;
	for (int i = s.size() - 1; i >= 0; i--)
		hash = hash * p + s[i];
	return hash;
}

ll merge_hash(ll a, int lena, ll b, int lenb, int p) {
	return a + b * binpow(p, lena);
}

//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////

struct segt {
	struct node {
		ll val, add = 0;
	};

	int n;
	vector<node>tree;

	void build(int v, int l, int r, vll&a) {
		auto& cur = tree[v];
		if (l == r)
			cur.val = a[l];
		else {
			int m = (l + r) / 2;
			build(v * 2, l, m, a);
			build(v * 2 + 1, m + 1, r, a);
			tree[v].val = min(tree[v * 2].val, tree[v * 2 + 1].val);
		}
	}

	void push(int v, int l, int r) {
		if (l != r && tree[v].add) {
			tree[v * 2].add += tree[v].add;
			tree[v * 2 + 1].add += tree[v].add;
		}
		tree[v].val += tree[v].add;
		tree[v].add = 0;
	}

	void modify(int v, int l, int r, int tl, int tr, int val) {
		push(v, l, r);
		if (l > tr || r < tl)
			return;
		if (l >= tl && r <= tr) {
			tree[v].add += val;
			push(v, l, r);
		}
		else {
			int m = (l + r) / 2;
			modify(v * 2, l, m, tl, tr, val);
			modify(v * 2 + 1, m + 1, r, tl, tr, val);
			tree[v].val = min(tree[v * 2].val, tree[v * 2 + 1].val);
		}
	}

	void update(int v, int l, int r, int pos, int val) {
		push(v, l, r);
		if (l > pos || r < pos)
			return;
		if (l == r)
			tree[v].val = val;
		else {
			int m = (l + r) / 2;
			update(v * 2, l, m, pos, val);
			update(v * 2 + 1, m + 1, r, pos, val);
			tree[v].val = min(tree[v * 2].val, tree[v * 2 + 1].val);
		}
	}

	ll query(int v, int l, int r, int tl, int tr) {
		push(v, l, r);
		if (l > tr || r < tl)
			return 1e9;
		if (l >= tl && r <= tr)
			return tree[v].val;
		else {
			int m = (l + r) / 2;
			ll a = query(v * 2, l, m, tl, tr);
			ll b = query(v * 2 + 1, m + 1, r, tl, tr);
			return min(a, b);
		}
	}

	segt(vll v) {
		tree.resize(4 * v.size());
		n = v.size();
		build(1, 0, n - 1, v);
	}
};

//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////

struct graph {
	vvp g;
	vll v;

	vi e(int v, int p = -1){
		vi res;
		for (auto i : g[v])
			if (i.first != p)
				res.push_back(i.first);
		return res;
	}

	graph(int n, int m) {
		g.resize(n);
		v.resize(n);

		for (int i = 0; i < m; i++) {
			int a = in - 1,
				b = in - 1;
			g[a].push_back({ b, 1 });
			g[b].push_back({ a, 1 });
		}
	}
};

//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////

void solve() {
	ll n = in;
	vll v(n);
	ll mx = -1e9;
	for (auto& i : v) {
		cin >> i;
		mx = max(mx, i);
	}
	
	ll p = -1;
	ll d = -1;

	for (ll i = 1; i < n; i++) {
		if (v[i] < v[i - 1]) {
			if (p != -1 && v[i] - v[i - 1] != v[p] - v[p - 1])
				return void(cout << -1 << '\n');
			p = i;
		}
		else {
			if (d != -1 && d != v[i] - v[i - 1])
				return void(cout << -1 << '\n');
			d = v[i] - v[i - 1];
		}
	}
	if (d == -1 || p == -1)
		cout << 0 << '\n';
	else if (v[p - 1] + d - v[p] <= mx)
		cout << -1 << '\n';
	else
		cout << v[p - 1] + d - v[p] << ' ' << d << '\n';
}

