#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
typedef pair<ld,ld> pld;

bool check(vector<ll> &v, ll n, ll m, ll c){
    vector<ll> t(n);
    t[0] = v[0];
    for(ll i = 1; i < n; i++){
        t[i] = (v[i-1] + c) % m;
        if(t[i] != v[i])
            return false;
    }
    return true;
}

void solve(){
    ll n;
    cin >> n;
    vector<ll> a(n);
    bool q = true;
    for(ll i = 0; i < n; i++){
        cin >> a[i];
       if(i == 0) continue;
       if(a[i] != a[i-1]) q = false;
    }
    if(q || n == 1){
        cout << 0 << "\n";
        return;
    }
    bool ok = true;
    ll v = -1, u = -1;
    for(ll i = 1; i < n; i++){
        if(a[i] > a[i-1]){
            if(v == -1)
                v = a[i] - a[i-1];
            else if(a[i] - a[i-1] != v)
                ok = false;
        }
        else if(a[i] < a[i-1]){
            if(u == -1)
                u = a[i-1] - a[i];
            else if(a[i-1] - a[i] != u)
                ok = false;
        }
        else
            ok = false;
    }
    if(!ok){
        cout << -1 << "\n";
        return;
    }
    if(v == -1 || u == -1)
        cout << 0 << "\n";
    else{
        ll c = v;
        ll i = 1;
        while(a[i] > a[i-1] && i < n)
            i++;
        ll m = a[i-1] + c - a[i];
        if(check(a,n,m,c) && c < m && a[0] < m)
            cout << m << " " << c << "\n";
        else
            cout << -1 << "\n";
    }
}

signed main(){
    ll T;
    cin >> T;
    while(T--)
        solve();
}
