﻿#include <iostream>
#include <vector>
#include <stack>
#include <unordered_set>
#include <map>
#include <algorithm>
#include <cmath>

#define deft1 template<typename t1>
#define deft2 template<typename t2>

using namespace std;

deft1
ostream& operator<<(ostream& out, vector<t1>& a);
template<typename t1, typename t2>
ostream& operator<<(ostream& out, pair<t1, t2>& a);

deft1
istream& operator>>(istream& in, vector<t1>& a) {
	for (auto& elem : a) in >> elem;
	return in;
}


deft1
class point {
public:
	t1 x;
	t1 y;
	point() {
		x = t1(0);
		y = t1(0);
	}
	point(t1 x, t1 y) {
		this->x = x;
		this->y = y;
	}

	t1 len() {
		return x * x + y * y;
	}

	// p + t2
	deft2
		friend point<t2> operator+(point<t2>& a, t2 b) {
		return point<t2>(a.x + b, a.y + b);
	}
	deft2
		friend point<t2> operator-(point<t2>& a, t2 b) {
		return point<t2>(a.x - b, a.y - b);
	}
	deft2
		friend point<t2> operator*(point<t2>& a, t2 b) {
		return point<t2>(a.x * b, a.y * b);
	}
	deft2
		friend point<t2> operator/(point<t2>& a, t2 b) {
		return point<t2>(a.x / b, a.y / b);
	}

	// p + p
	deft2
		friend point<t2> operator+(point<t2>& a, point<t2>& b) {
		return point<t2>(a.x + b.x, a.y + b.y);
	}
	deft2
		friend point<t2> operator-(point<t2>& a, point<t2>& b) {
		return point<t2>(a.x - b.x, a.y - b.y);
	}
	deft2
		friend t2 operator*(point<t2>& a, point<t2>& b) {
		return a.x * b.x + a.y * b.y;
	}
	deft2
		friend t2 operator^(point<t2>& a, point<t2>& b) {
		return a.x * b.y - a.y * b.x;
	}

	// in/output
	deft2
		friend ostream& operator<<(ostream& out, point<t2> a) {
		out << a.x << " " << a.y;
		return out;
	}
	deft2
		friend istream& operator>>(istream& in, point<t2>& a) {
		in >> a.x >> a.y;
		return in;
	}
};

void solution() {
	int n;
	cin >> n;
	vector<long long int> data(n);
	cin >> data;
	if (n <= 2) {
		cout << 0 << endl;
		return;
	}

	long long int d1 = -1;
	long long int d2 = -1;
	for (int i = 0; i < n - 1; i++) {
		long long int d_now = abs(data[i] - data[i + 1]);
		if (data[i] >= data[i + 1]) {
			if (d1 == -1) d1 = d_now;
			else if (d1 != d_now) {
				cout << -1 << endl;
				return;
			}
		}
		if (data[i] <= data[i + 1]) {
			if (d2 == -1) d2 = d_now;
			else if (d2 != d_now) {
				cout << -1 << endl;
				return;
			}
		}
	}

	if (d1 == -1 || d2 == -1) {
		cout << 0 << endl;
		return;
	}
	else if (d2 == 0 && d1 == 0) {
		cout << 0 << endl;
		return;
	}
	else {
		long long int m = d1 + d2;
		long long int c = d2;
		for (int i = 0; i < n; i++) {
			if (data[i] >= m) {
				cout << -1 << endl;
				return;
			}
		}
		cout << m << " " << c << endl;
	}

}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t = 0;
	cin >> t;
	for (int i = 0; i < t; i++) solution();
}

deft1
ostream& operator<<(ostream& out, vector<t1>& a) {
	if (a.size() == 0) out << "[]";
	else {
		out << "[" << a[0];
		for (int i = 1; i < a.size(); i++) {
			out << " " << a[i];
		}
		out << "]";
	}
	return out;
}
template<typename t1, typename t2>
ostream& operator<<(ostream& out, pair<t1, t2>& a) {
	out << "{ " << a.first << ", " << a.second << " }";
}
