#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pll = pair<ll, ll>;
using pii = pair<int, int>;

#define sz(x) (int((x).size()))
#define pb push_back
#define ins insert
#define ers erase

template<typename T>
T gcd(T a, T b) {
    return b ? gcd(b, a % b) : a;
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll MAXN = 1e5 + 10;

ll a[MAXN];

void solve() {
    int n;
    cin >> n;

    bool inc = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];

        if (i != 0 && a[i] < a[i - 1]) {
            inc = false;
        }
    }

    if (inc) {
        ll diff = a[1] - a[0];
        for (int i = 2; i < n; i++) {
            if (diff != a[i] - a[i - 1]) {
                cout << -1;
                return;
            }
        }

        cout << 0;
        return;
    }

    ll plus_diff = -1, minus_diff = 1;
    for (int i = 1; i < n; i++) {
        ll cur_diff = a[i] - a[i - 1];

        if (cur_diff < 0) {
            if (minus_diff != 1 && cur_diff != minus_diff) {
                cout << -1;
                return;
            }

            minus_diff = cur_diff;
        } else {
            if (plus_diff != -1 && cur_diff != plus_diff) {
                cout << -1;
                return;
            }

            plus_diff = cur_diff;
        }
    }

    ll mod, diff;

    if (plus_diff != -1) {
        mod = (abs(minus_diff) + abs(plus_diff)), diff = plus_diff;
    } else {
        cout << 0;
        return;
    }

    if (a[0] >= mod) {
        cout << -1;
        return;
    }

    ll cur = a[0];
    for (int i = 1; i < n; i++) {
        cur += diff;
        cur %= mod;
        if (a[i] != cur) {
            cout << -1;
            return;
        }
    }

    cout << mod << " " << diff;
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);

    int t = 1;

#ifdef _LOCAL_JUDGE
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    cin >> t;
#else
    cin >> t;
#endif

    while (t--) {
        solve();
        cout << "\n";
    }

    return 0;
}
