#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {117, 239, signed(1e5) + 3, 177013};
const int MAXN = signed(1e5) + 100, MAXLOG = 20;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

inline void solve() {
    int n; cin >> n;
    vector<int> a(n);
    for (auto &i : a) cin >> i;

    set<int> check;
    for (auto i : a) check.insert(i);

    if (sz(check) == 1) {
        cout << "0\n";
        return;
    }

    for (int i = 1; i < n; ++i) {
        if (a[i - 1] == a[i]) {
            cout << "-1\n";
            return;
        }
    }

    bool onlyUp = true;

    for (int i = 1; i < n; ++i) {
        if (a[i] < a[i - 1]) {
            onlyUp = false;
            break;
        }
    }

    if (onlyUp) {
        int c = a[1] - a[0];

        for (int i = 2; i < n; ++i) {
            if (a[i] - a[i - 1] != c) {
                cout << "-1\n";
                return;
            }
        }

        cout << "0\n";
        return;
    }

    bool onlyDown = true;

    for (int i = 1; i < n; ++i) {
        if (a[i] > a[i - 1]) {
            onlyDown = false;
            break;
        }
    }

    if (onlyDown) {
        int c = a[1] - a[0];

        for (int i = 2; i < n; ++i) {
            if (a[i] - a[i - 1] != c) {
                cout << "-1\n";
                return;
            }
        }

        cout << "0\n";
        return;
    }

    int limitMod = *max_element(a.begin(), a.end()); // mod > limitMod
    int c = -INF;

    for (int i = 0; i < n - 1; ++i) {
        if (a[i] < a[i + 1]) {
            c = a[i + 1] - a[i];
            break;
        }
    }

    assert(c != -INF);
    int mod = -INF;

    for (int i = 0; i < n - 1; ++i) {
        if (a[i + 1] < a[i]) {
            mod = a[i] + c - a[i + 1];
            break;
        }
    }

    assert(mod != -INF);
    
    if (mod <= limitMod) {
        cout << "-1\n";
        return;
    }

    int x = a[0];

    for (int i = 1; i < n; ++i) {
        x = (x + c) % mod;

        if (x != a[i]) {
            cout << "-1\n";
            return;
        }
    }

    cout << mod << " " << c << "\n";
}

signed main() {
    fastio;
#ifdef hikki
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int q; cin >> q;
    while (q--) solve();

    return 0;
}