#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <deque>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <numeric>
#include <algorithm>
#include <ctime>
#include <cstdlib>
#include <string>

//#define int long long
#define ll long long
#define ld long double
#define accuracy(x) fixed << setprecision(x)

const int INF = (int)1e9;
const long long LINF = (long long)1e18;
const long double EPS = 1e-9;
const long double PI = acos(-1.0);

using namespace std;

void fast_io()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

void file_in(string& filename)
{
    freopen(filename.c_str(), "r", stdin);
}

void file_out(string& filename)
{
    freopen(filename.c_str(), "w", stdout);
}

ld my_difftime(clock_t start, clock_t end)
{
    return (ld)(end - start) / ((ld)CLOCKS_PER_SEC / 1000);
}

void sleep(ld milliseconds)
{
    clock_t start = clock();
    for (clock_t end = clock(); my_difftime(start, end) < milliseconds; end = clock()) {}
}

void solve()
{
    int n;
    cin >> n;
    if (n == 1)
    {
        cout << "0\n";
        return;
    }
    vector<int> arr(n);
    int max_value = -INF;
    for (int i = 0; i < n; ++i)
    {
        cin >> arr[i];
        max_value = max(max_value, arr[i]);
    }
    int m, c, expr;
    m = c = expr = -1;
    bool is_c_zero = true;
    for (int i = 0; i < n - 1; ++i)
    {
        if (arr[i + 1] >= arr[i])
        {
            int new_c = arr[i + 1] - arr[i];
            if (c == -1)
            {
                c = new_c;
            }
            else if (c != new_c)
            {
                cout << "-1\n";
                return;
            }
        }
        else
        {
            is_c_zero = false;
            if (expr == -1)
            {
                expr = arr[i] - arr[i + 1];
            }
            else if (expr != arr[i] - arr[i + 1])
            {
                cout << "-1\n";
                return;
            }
        }
    }
    if ((c == -1) && (expr == -1))
    {
        cout << "-1\n";
        return;
    }
    if ((c == -1) && (expr != -1))
    {
        cout << "0\n";
        return;
    }
    if ((c != -1) && (expr == -1))
    {
        cout << "0\n";
        return;
    }
    if ((c == 0) && !is_c_zero)
    {
        cout << "-1\n";
        return;
    }
    m = expr + c;
    if (m <= max_value)
    {
        cout << "-1\n";
        return;
    }
    cout << m << ' ' << c << '\n';
}


signed main()
{
#ifndef LOCAL
    fast_io();
#else
    clock_t start = clock();
#endif

    int t;
    cin >> t;
    for (; t > 0; --t)
    {
        solve();
    }

#ifdef LOCAL
    cerr << "TIME: " << accuracy(2) << my_difftime(start, clock()) << '\n';
#endif

}