#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>

#include "ext/rope"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"
#include <ctime>

#ifndef LOCAL_BUILD
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#endif

namespace {
    using namespace std;
    using namespace __gnu_cxx;
    using namespace __gnu_pbds;
    
    typedef long long ll;
    typedef long double ld;
    
    typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update, allocator<char>> ordered_set;
    
    const int MOD = 1e9 + 7;
    const int INF = 1e9 + 33;
    const ll LLINF = 1e18 + 11;
    const ld EPS = 1e-8;

#define speed ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
    
    template<typename T>
    istream& operator>>(istream& in, vector<T>& r) {
        for (auto& e : r)
            cin >> e;
    }
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {
        cin >> p.first >> p.second;
    }
    
    template<typename T>
    ostream& operator<<(ostream& out, vector<T>& r) {
        for (auto& e : r)
            cout << e << ' ';
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("test.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
    speed;
    int t; cin >> t; while (t--)
    solve();
}

void solve() {
    int n;
    cin >> n;
    vector<ll> a(n);
    cin >> a;
    if (n <= 2) {
        cout << "0\n";
        return;
    }
    ll ma = 0;
    for (ll e : a)
        ma = max(ma, e);
    int cnt = 0;
    ll c1 = 0, c2 = 0, m = 0;
    for (int i = 0; i < n - 1; i++) {
        ll diff = a[i + 1] - a[i];
        if (cnt == 0) {
            c1 = diff;
            cnt++;
        }
        else if (cnt == 1 && c1 != diff) {
            cnt++;
            c2 = diff;
            m = abs(c1 - c2);
        } else if (cnt == 2) {
            if (diff != c1 && diff != c2) {
                cnt = 3;
                break;
            }
        }
    }
    if (cnt == 3 || ma >= m && cnt == 2) {
        cout << "-1\n";
        return;
    }
    if (cnt == 1)
        cout << "0\n";
    else
        cout << m << ' ' << max(c1, c2) << '\n';
}