#ifdef LOCAL
#include "debug.h"
#else
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x)
#endif

//#define int ll

using namespace std;

typedef long long ll;
typedef long double ld;
#define sz(x) int(x.size())

template <typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;

#ifdef LOCAL
mt19937 rng(1000 - 7);
#else
mt19937 rng(time(0));
#endif

const int N = 1e5 + 10;
const int MOD = 1e9 + 7;
const ld eps = 5e-8;

vector <int> a[N], b[N];
int cnt[N];
int ans[N];

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    int q;
    cin >> q;

    while (q--) {
        int n, m;
        cin >> n >> m;

        for (int i = 0; i < n; i++) {
            cnt[i] = 0;
            b[i].clear();
        }

        for (int i = 0; i < m; i++) {
            ans[i] = -1;
            a[i].clear();

            int k;
            cin >> k;

            while (k--) {
                int x;
                cin >> x;

                x--;
                a[i].push_back(x);
                b[x].push_back(i);
            }
        }

        int z = (m + 1) / 2;
        for (int i = 0; i < n; i++) {
            if (sz(b[i]) <= z) {
                for (int d : b[i]) {
                    ans[d] = i;
                }
            }
        }

        vector <int> v;
        for (int i = 0; i < m; i++) {
            if (ans[i] == -1) {
                v.push_back(i);
            }
        }

        sort(v.begin(), v.end(), [&] (int i, int j) {
            return sz(a[i]) < sz(a[j]);
        });

        bool e = false;
        for (int i : v) {
            bool flag = true;
            for (int x : a[i]) {
                if (cnt[x] + 1 <= z) {
                    cnt[x]++;
                    ans[i] = x;
                    flag = false;
                    break;
                }
            }

            if (flag) {
                e = true;
                break;
            }
        }

        if (e) {
            cout << "NO\n";
        } else {
            cout << "YES\n";
            for (int i = 0; i < m; i++) {
                cout << ans[i] + 1 << " ";
            }
            cout << "\n";
        }
    }

    return 0;
}
