//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC optimize("unroll-loops,rename-registres")

#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
#include <bitset>
#include <iomanip>
#include <numeric>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 998'244'353;
const ll P = 179, Q = 239;
const ll A = 26;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll sign(ll x) {
	if (x < 0) return -1;
	if (x == 0) return 0;
	return 1;
}

inline bool maxi(ll &a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

inline bool mini(ll &a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

inline ll add(ll a, ll b) {
	a += b;
	if (a >= mod) {
		a -= mod;
	}
	return a;
}

inline ll sub(ll a, ll b) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
	return a;
}

inline void addl(ll &a, ll b) {
	a += b;
	if (a >= mod) {
		a -= mod;
	}
}

inline void subl(ll &a, ll b) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
}

inline ll mul(ll a, ll b) {
	return (a * b) % mod;
}

inline void mull(ll &a, ll b) {
	a = (a * b) % mod;
}

ll n, m;
ll k;
ll q;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	ll beg = clock();

	ll t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		map <ll, ll> cnt;
		vector <vector <ll>> a(m);
		for (int i = 0; i < m; ++i) {
			cin >> k;
			for (int j = 0; j < k; ++j) {
				ll x;
				cin >> x;
				a[i].push_back(x);
			}
			if (k == 1) {
				cnt[a[i][0]]++;
			}
		}
		vector <ll> ans(m);
		bool bad = false;
		for (int i = 0; i < m; ++i) {
			if (a[i].size() == 1) {
				ans[i] = a[i][0];
				continue;
			}
			ll mine = INF;
			ll el = -1;
			for (auto &x : a[i]) {
				if (mini(mine, cnt[x])) {
					el = x;
				}
			}
			ans[i] = el;
			++cnt[el];
		}
		for (auto &x : cnt) {
			if (x.second > (m + 1) / 2) {
				bad = true;
				break;
			}
		}
		if (bad) {
			cout << "NO\n";
		}
		else {
			cout << "YES\n";
			for (auto &x : ans) {
				cout << x << ' ';
			}
			cout << '\n';
		}
		
	}

	cerr << "Process terminated in " << (clock() - beg) * 1.0l / CLOCKS_PER_SEC << "s\n";
	return 0;
}