#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

template <typename type>
void print(const vector <type> &massive, const string &sep = " ", const string &end = "\n") {
    if (!massive.empty()) {
        auto it = massive.begin();
        cout << *it;
        ++it;

        for (; it != massive.end(); ++it) {
            cout << sep << *it;
        }
    }

    cout << end;
}

template <typename type>
inline void print(const type &elem, const string &end = "\n") {
    cout << elem << end;
}

inline void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

template <typename type>
inline void sort(vector <type> &massive) {
    sort(massive.begin(), massive.end());
}

template <typename type>
inline void reverse(vector <type> &massive) {
    reverse(massive.begin(), massive.end());
}

bool cmp(const pair <vector <size_t>, size_t> &left, const pair <vector <size_t>, size_t> &right) {
    return left.first.size() < right.first.size();
}

void solve() {
    size_t n, m;
    cin >> n >> m;
    vector <pair <vector <size_t>, size_t>> friends(m);

    for (size_t i = 0; i < friends.size(); ++i) {
        size_t size;
        cin >> size;
        friends[i].first.resize(size);
        friends[i].second = i;
        for (auto &f : friends[i].first) {
            cin >> f;
        }
    }

    sort(friends.begin(), friends.end(), cmp);

    size_t border = m / 2;
    if (m % 2 != 0) {
        ++border;
    }

    unordered_map <size_t, size_t> counter;

    vector <size_t> ans(m, 0);
    bool ok = true;
    for (const auto &i : friends) {
        size_t f = 0, days = 1e9;
        for (auto j : i.first) {
            if (counter[j] < days) {
                f = j;
                days = counter[j];
            }
        }
        ++counter[f];
        ans[i.second] = f;

        if (f == 0 || counter[f] > border) {
            ok = false;
            break;
        }
    }

    if (ok) {
        print("YES");
        print(ans);
    } else {
        print("NO");
    }
}

int main() {
    fast();

    size_t t;
    cin >> t;
    for (size_t never_use = 0; never_use < t; ++never_use) {
        solve();
    }

    return 0;
}
