#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <unordered_map>
#include <algorithm>
#include <cstring>
#include <sstream>
#include <functional>
#include <unordered_set>
#include <array>
#include <deque>
#include <chrono>
#include <random>

#define err(x) {cerr << "["#x"]  " << (x) << '\n';}
#define errv(x) {cerr << "["#x"]  ["; for (const auto& ___ : (x)) cerr << (___) << ", "; cerr << "]\n";}
#define errvn(x, n) {cerr << "["#x"]  ["; for (int ___ = 0; ___ < (n); ++___) cerr << ((x)[___]) << ", "; cerr << "]\n";}
#define errf() {cerr << "\n\n";}
#define sq(x) ((x)*(x))

using ll = long long;
using ld = long double;
using ull = unsigned long long;

using namespace std;

//mt19937 rng(random_device());

template<typename T1, typename T2>
inline bool relax(T1& a, const T2& b) {
    if (a > b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T1, typename T2>
inline bool strain(T1& a, const T2& b) {
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

// ::::::::::::::::::::::::::::::::::::;

void solve() {
    int n, m;
    cin >> n >> m;

    vector<int> res(m);
    vector<vector<int>> a(m);
    map<int, int> cnt;
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;

        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            a[i].emplace_back(x);
        }
        if (k == 1) {
            ++cnt[a[i][0]];
            res[i] = a[i][0];
        }
    }

    for (int i = 0; i < m; ++i) {
        if (a[i].size() > 1) {
            int cur = -1;
            for (int j : a[i]) {
                if (cur == -1 || cnt[cur] > cnt[j])
                    cur = j;
            }
            ++cnt[cur];
            res[i] = cur;
        }
    }
    for (auto p : cnt) {
        if (p.second > ((m + 1) / 2)) {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n";
    for (int i = 0; i < m; ++i)
        cout << res[i] << ' ';
    cout << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr); cout.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();

    return 0;
}

