#pragma GCC optimize("Ofast")

#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>

typedef std::pair<int, int> pii;
typedef unsigned long long ull;
typedef long long ll;
typedef long double lb;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define file_in freopen("input.txt", "r", stdin);
#define file_out freopen("output.txt", "w", stdout);
#define all(x) (x).begin(), (x).end()
#define fi first
#define se second

using namespace std;

template<typename T>
istream& operator>>(istream& in, vector<T> &v) {
	for (auto &it : v) {
		in >> it;
	}
	return in;
}

template<typename T>
ostream& operator<<(ostream& out, vector<T> &v) {
	for (auto &it : v) {
		out << it << " ";
	}
	return out;
}

template<typename T1, typename T2>
istream& operator>>(istream& in, pair<T1, T2> &v) {
	in >> v.fi >> v.se;
	return in;
}


template<typename T1, typename T2>
ostream& operator<<(ostream& out, pair<T1, T2> &v) {
	out << v.fi << " " << v.se;
	return out;
}

bool cmp(pair<int, set<int>> &p1, pair<int, set<int>> &p2) {
	return p1.se.size() < p2.se.size();
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<int> cnt(n);
	int k;
	vector<pair<int, set<int>>> days(m);
	
	for (int i = 0; i < m; ++i) {
		cin >> k;
		int f;
		set<int> b;
		for (int i = 0; i < k; ++i) {
			cin >> f; 
			--f;
			b.insert(f);
		}
		days[i] = {i, b};
	}
	sort(all(days), cmp);
	vector<map<int, int>> cnt_all(m);
	for (int i = m - 1; i >= 0; --i) {
		for (auto el : days[i].se) {
			cnt[el]++;
			cnt_all[i][el] = cnt[el];
		}
	}
	
	vector<int> ans(m);
	cnt.clear();
	cnt.resize(n);

	for (int i = 0; i < m; ++i) {
		int mi = *(days[i].se.begin());
		for (auto el : days[i].se) {
			if (cnt[mi] > cnt[el] || (cnt[mi] == cnt[el] && cnt_all[i][mi] >= cnt_all[i][el])) {
				mi = el;
			}
		}
		ans[days[i].fi] = mi + 1;
		cnt[mi]++;
		if (cnt[mi] > m / 2 + m % 2) {
			cout << "NO" << '\n';
			return;
		}
		// cout << ans << '\n';
	}
	cout << "YES" << '\n';
	cout << ans << '\n';
}

int main() {
	fast
	// file_in

	int t;
	cin >> t;
	while (t--) {
		solve();
	}

	return 0;
}