#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

#define int ll

using namespace std;
typedef long long ll;

const int MAXN = 100010;

int sizes[MAXN];
int occur[MAXN];

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (sizes[a.first] == sizes[b.first]) {
        return occur[a.second] < occur[b.second];
    }
    return sizes[a.first] < sizes[b.first];
}

signed main()
{
    int q;
    cin >> q;
    while (q--) {
        int n, m;
        cin >> n >> m;
        for (int i = 0; i < n; ++i) {
            occur[n] = 0;
        }
        vector<pair<int, int>> friends;
        vector<int> days(m);
        int k = (m + 1) / 2;
        vector<int> taken(n);
        for (int i = 0; i < m; ++i) {
            int sz;
            cin >> sz;
            sizes[i] = sz;
            for (int j = 0; j < sz; ++j) {
                int x;
                cin >> x;
                ++occur[x - 1];
                friends.emplace_back(i, x - 1);
            }
        }
        sort(friends.begin(), friends.end(), cmp);
        for (int i = 0; i < friends.size(); ++i) {
            if (!days[friends[i].first] && taken[friends[i].second] < k) {
                days[friends[i].first] = friends[i].second + 1;
                ++taken[friends[i].second];
            }
        }
        bool flag = true;
        for (int i = 0; i < m; ++ i) {
            if (!days[i]) {
                flag = false;
            }
        }
        if (flag) {
            cout << "YES\n";
            for (int i = 0; i < m; ++ i) {
                cout << days[i] << ' ';
            }
            cout << '\n';
        } else {
            cout << "NO\n";
        }
    }
}
