//package start;

import java.io.*;
import java.util.*;
import java.lang.*;

public class Main extends IO {

    public static void main(String[] args) throws IOException {
        int quantity = readInt();
        HashMap<Integer, Integer> count = new HashMap<>();

        mainCycle:
        for (int x = 0; x < quantity; x++) {
            count.clear();
            int[] properties = readArrayInt(" ");
            int[][] data = new int[properties[1]][];
            int[] answer = new int[properties[1]];
            int maxCount = (int) Math.ceil(((double) properties[1]) / 2);
            boolean exit = false;
            for (int i = 0; i < properties[1]; i++) {
                data[i] = Arrays.stream(readString().substring(2).split(" ")).mapToInt(Integer::parseInt).toArray();
                if (data[i].length == 1) {
                    answer[i] = data[i][0];
                    if (count.getOrDefault(answer[i], 0) + 1 > maxCount) {
                        if (!exit) {
                            writeString("NO", "\n");
                        }
                        exit = true;
                        continue ;
                    }
                    if (!exit) {
                        count.merge(answer[i], 1, Integer::sum);
                    }
                }
            }
            if (exit){
                continue;
            }

            for (int i = 0; i < properties[1]; i++) {
                if (answer[i] == 0) {
                    boolean flag = false;
                    for (int user : data[i]) {
                        if (count.getOrDefault(user, 0) + 1 <= maxCount) {
                            answer[i] = user;
                            count.merge(answer[i], 1, Integer::sum);
                            flag = true;
                            break;
                        }
                    }
                    if (!flag) {
                        writeString("NO", "\n");
                        continue mainCycle;
                    }
                }
            }
            writeString("YES", "\n");
            writeArray(answer, " ", "\n");

        }
        print();
    }
}


class Pair<T, U> {
    T first;
    U second;

    Pair(T first, U second) {
        this.first = first;
        this.second = second;
    }

    @Override
    public int hashCode() {
        return 31 * first.hashCode() * second.hashCode() - (first.hashCode() ^ second.hashCode());
    }

    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof Pair)) {
            return false;
        }
        Pair p = (Pair) obj;
        return this.first == p.first && this.second == p.second;
    }
}

class IO {

    private static BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    private static BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));

    static String readString() throws IOException {
        return reader.readLine();
    }

    static int readInt() throws IOException {
        return Integer.parseInt(reader.readLine());
    }

    static long readLong() throws IOException {
        return Long.parseLong(reader.readLine());
    }

    static int[] readArrayInt(String split) throws IOException {
        return Arrays.stream(reader.readLine().split(split)).mapToInt(Integer::parseInt).toArray();
    }

    static void writeInt(int value, String end) throws IOException {
        writer.write(Integer.toString(value));
        writer.write(end);
    }

    static void writeLong(long value, String end) throws IOException {
        writer.write(Long.toString(value));
        writer.write(end);
    }

    static void writeString(String value, String end) throws IOException {
        writer.write(value);
        writer.write(end);
    }

    static void writeArray(int[] array, String sep, String end) throws IOException {
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < array.length; i++) {
            builder.append(array[i]);
            if (i + 1 < array.length) {
                builder.append(sep);
            }
        }
        builder.append(end);
        writer.write(builder.toString());
    }

    static void writeArray(long[] array, String sep, String end) throws IOException {
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < array.length; i++) {
            builder.append(array[i]);
            if (i + 1 < array.length) {
                builder.append(sep);
            }
        }
        builder.append(end);
        writer.write(builder.toString());
    }

    static void writeArray(String[] array, String sep, String end) throws IOException {
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < array.length; i++) {
            builder.append(array[i]);
            if (i + 1 < array.length) {
                builder.append(sep);
            }
        }
        builder.append(end);
        writer.write(builder.toString());
    }

    static void print(boolean exit) throws IOException {
        writer.flush();
        if (exit) {
            reader.close();
            writer.close();
        }
    }

    static void print() throws IOException {
        print(false);
    }


}