#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <bitset>
#include <tuple>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

ll bpow(ll a, ll p, ll md) {
	if (p == 0) return 1ll;
	if (p % 2) return (bpow(a, p - 1, md) * a) % md;
	ll b = bpow(a, p / 2, md);
	return (b * b) % md;
}

const ll SZ = 2e5 + 100, MOD = 1e9 + 7, INF = 1e9 * 1e9 + 100;

vector<pair<ll, vector<ll>>> days;

bool cmp(pair<ll, vector<ll>>& a, pair<ll, vector<ll>>& b) {
	return a.second.size() < b.second.size();
}

vector<ll> cnt;
bool cmp2(int i1, int i2) {
	return cnt[i1] < cnt[i2];
}

void sol() {
	ll n, m;
	cin >> n >> m;

	days.clear();
	days.resize(n);
	cnt.clear();
	cnt.resize(m);

	vector<ll> ans(m);
	for (int i = 0; i < m;i++) ans[i] = -1;
	for (int i = 0; i < n; i++) days[i].first = i;

	for (int i = 0; i < m; i++) {
		ll k;
		cin >> k;
		cnt[i] = k;
		for (int j = 0; j < k; j++) {
			ll fr;
			cin >> fr;
			fr--;
			days[fr].second.push_back(i);
		}
	}

	sort(days.begin(), days.end(), cmp);
	ll cnt = 0;
	for (int i = 0; i < n; i++) {
		cnt = 0;
		sort(days[i].second.begin(), days[i].second.end(), cmp2);
		for (auto c : days[i].second) {
			if (ans[c] == -1 && cnt * 2 < m) {
				cnt++;
				ans[c] = days[i].first;
			}
		}
	}

	bool f = 1;
	for (int i = 0; i < m; i++) {
		if (ans[i] == -1) f = 0;
	}

	if (f == 0) {
		cout << "NO\n";
	}
	else {
		cout << "YES\n";
		for (auto c : ans) cout << c + 1 << " ";
		cout << "\n";
	}
}

int main() {
	fastInp;

	ll t;
	cin >> t;
	while (t--) {
		sol();
	}

	return 0;
}