#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <stack>
#include <deque>
#include <queue>
#include <random>
#include <string>
#include <ctime>
#include <cassert>
#include <chrono>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) (int)(x).size()
typedef unsigned int uint;
typedef long long ll;
typedef unsigned long long ull;
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<long long, long long> pll;

const int INF = 1e9 + 7;
const ll INFLL = 1e18;

mt19937_64 rng(time(0));

bool IS_ONE_TEST = 0;

struct day {
    int id;
    vector<int> f;

    day() : id(-1) {}
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<day> days(m);
    vector<int> cnt(n + 1, 0), used(n + 1, 0);
    for (int i = 0; i < m; ++i) {
        int k;
        cin >> k;
        days[i].id = i;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            days[i].f.emplace_back(x);
        }
    }
    int max_day = (m + 1) / 2;
    vector<int> ans(m, -1);
    sort(days.begin(), days.end(), [](day &x, day &y) {
        return (int)(x.f.size()) < (int)(y.f.size());
    });
    for (auto &d: days) {
        int cur = -1;
        for (auto &fr: d.f) {
            if (cur == -1 && used[fr] + 1 <= max_day || used[fr] < used[cur] && used[fr] + 1 <= max_day) {
                cur = fr;
            }
        }
        if (cur == -1) {
            cout << "NO" << en;
            return;
        }
        ans[d.id] = cur;
        ++used[cur];
    }
    for (auto &f: used) {
        if (f > max_day) {
            cout << "NO" << en;
            return;
        }
    }
    cout << "YES" << en;
    for (auto &i: ans) cout << i << ' ';
    cout << en;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int TESTS = 1;
    if (!IS_ONE_TEST) cin >> TESTS;
    while (TESTS--) { solve(); }
    return 0;
}
