﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <bitset>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
	if (b == 0)
		return a;
	return gcd(b, a % b);
}
ll lcm(ll a, ll b) {
	return a / gcd(a, b) * b;
}
ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n % 2 == 0) {
		ll b = bin_pow(a, n / 2);
		return b * b;
	}
	return bin_pow(a, n - 1) * a;
}
struct vertex {
	int x;
	vertex() = default;
	vertex(int a) {
		x = a;
	}
	bool operator<(vertex b) {
		return x < b.x;
	}
};
vector<vertex>tree;
vertex trash;

/*void build(int l, int r, int v) {
	if (l + 1 == r) {
		tree[v] = 0;
		return;
	}
	int m = (l + r) / 2;
	build(l, m, 2 * v + 1);
	build(m, r, 2 * v + 2);
	tree[v] = (tree[2 * v + 1], tree[2 * v + 2]);
}
void update(int ql, int qr, int x, int l, int r, int v) {
	if (ql <= l && r <= qr) {

		return;
	}
	if (r <= ql || qr <= l) {
		return;
	}
	int m = (l + r) / 2;
	update(ql, qr, x, l, m, 2 * v + 1);
	update(ql, qr, x, m, r, 2 * v + 2);
	tree[v] = (tree[2 * v + 1], tree[2 * v + 2]);
}
vertex get(int ql, int qr, int l, int r, int v) {
	if (ql <= l && r <= qr) {
		return tree[v];
	}
	if (r <= ql || qr <= l) {
		return trash;
	}
	int m = (l + r) / 2;
	vertex l = get(ql, qr, l, m, 2 * v + 1), r = get(ql, qr, m, r, 2 * v + 2);
	return (l, r);
}*/

struct day {
	vector<int>hs;
	int i;
	day() = default;
	bool operator< (day b) {
		return hs.size() < b.hs.size();
	}
};

int main() {
	cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
	int t; cin >> t;
	while (t--) {
		int n, m; cin >> n >> m;
		vector<int>ans(n);
		vector<int>out(m);
		vector<day>days(m);
		vector<int>kol(n);
		for (int i = 0; i < m; i++) {
			int k; cin >> k;
			days[i].i = i;
			for (int j = 0; j < k; j++) {
				int h; cin >> h;
				h--;
				days[i].hs.push_back(h);
				kol[h]++;
			}
		}
		sort(days.begin(), days.end());
		for (int i = 0; i < m; i++) {
			int best = 1e7, bj = -1;
			for (auto h:days[i].hs) {
				if (ans[h] < best || (ans[h] == best && kol[h] < kol[bj])) {
					best = ans[h];
					bj = h;
				}
			}
			ans[bj]++;
			out[days[i].i] = bj + 1;
		}
		bool flag = true;
		for (auto i : ans)
			if (i > (m + 1) / 2)
				flag = false;
		if (flag) {
			cout << "YES\n";
			for (auto i : out)
				cout << i << ' ';
			cout << '\n';
		}
		else
			cout << "NO\n";
	}
	return 0;
}