// #include "pch.h"


#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>


using namespace::std;
int INF = 1e9 + 100;

// #define cout fout
// ofstream fout("output.txt");


struct line {
	vector<int>v;
	int i;
};


bool cmp1(line &a, line &b) {
	if (a.v.size() == b.v.size()) return a.i < b.i;
	return a.v.size() < b.v.size();
}


bool cmp2(line &a, line &b) {
	return a.i < b.i;
}


void solve() {
	// cout << "**************\n";

	int n, m;
	cin >> n >> m;
	vector<int>was(n + 1);
	vector<line>v(m);
	for (int i = 0; i < m; i++) {
		int sz;
		cin >> sz;
		v[i].v.resize(sz);
		for (auto &e : v[i].v)
			cin >> e;
		v[i].i = i;
	}

	vector<int>ans(m);
	sort(v.begin(), v.end(), cmp1);


	int maxwas = 0;
	for (auto eline : v) {
		int minv = INF;
		int resv = INF;
		for (auto e : eline.v) {
			if (minv > was[e]) {
				minv = was[e];
				resv = e;
			}
		}
		ans[eline.i] = resv;
		was[resv]++;
		maxwas = max(maxwas, was[resv]);
	}

	if (maxwas > (m + 1) / 2) cout << "NO\n";
	else {
		cout << "YES\n";
		for (auto &e : ans) cout << e << " ";
		cout << "\n";
	}



}



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	cout.setf(ios::fixed);
	cout.precision(10);


	int tt = 1;
	cin >> tt;
	for (int t = 0; t < tt; t++)
		solve();


	return 0;
}
