﻿#include <iostream>
#include <vector>
#include <stack>
#include <unordered_set>
#include <map>
#include <algorithm>
#include <cmath>

#define deft1 template<typename t1>
#define deft2 template<typename t2>

using namespace std;

deft1
ostream& operator<<(ostream& out, vector<t1>& a);
template<typename t1, typename t2>
ostream& operator<<(ostream& out, pair<t1, t2>& a);

deft1
istream& operator>>(istream& in, vector<t1>& a) {
	for (auto& elem : a) in >> elem;
	return in;
}


deft1
class point {
public:
	t1 x;
	t1 y;
	point() {
		x = t1(0);
		y = t1(0);
	}
	point(t1 x, t1 y) {
		this->x = x;
		this->y = y;
	}

	t1 len() {
		return x * x + y * y;
	}
	
	// p + t2
	deft2
	friend point<t2> operator+(point<t2>& a, t2 b) {
		return point<t2>(a.x + b, a.y + b);
	}
	deft2
	friend point<t2> operator-(point<t2>& a, t2 b) {
		return point<t2>(a.x - b, a.y - b);
	}
	deft2
	friend point<t2> operator*(point<t2>& a, t2 b) {
		return point<t2>(a.x * b, a.y * b);
	}
	deft2
	friend point<t2> operator/(point<t2>& a, t2 b) {
		return point<t2>(a.x / b, a.y / b);
	}

	// p + p
	deft2
	friend point<t2> operator+(point<t2>& a, point<t2>& b) {
		return point<t2>(a.x + b.x, a.y + b.y);
	}
	deft2
	friend point<t2> operator-(point<t2>& a, point<t2>& b) {
		return point<t2>(a.x - b.x, a.y - b.y);
	}
	deft2
	friend t2 operator*(point<t2>& a, point<t2>& b) {
		return a.x * b.x + a.y * b.y;
	}
	deft2
	friend t2 operator^(point<t2>& a, point<t2>& b) {
		return a.x * b.y - a.y * b.x;
	}

	// in/output
	deft2
	friend ostream& operator<<(ostream& out, point<t2> a) {
		out << a.x << " " << a.y;
		return out;
	}
	deft2
	friend istream& operator>>(istream& in, point<t2>& a) {
		in >> a.x >> a.y;
		return in;
	}
};

void solution() {
	int n, m;
	cin >> n >> m;
	vector<vector<int>> free_friends(m);
	for (int i = 0; i < m; i++) {
		int k;
		cin >> k;
		free_friends[i] = vector<int>(k);
		for (auto& elem : free_friends[i]) cin >> elem;
		sort(free_friends[i].begin(), free_friends[i].end());
	}

	vector<int> answ(m, -1);
	map<int, int> cnt_pick;
	for (int i = 0; i < m; i++) {
		if (free_friends[i].size() == 1) {
			answ[i] = free_friends[i][0];
			cnt_pick[free_friends[i][0]]++;
		}
	}
	for (int i = 0; i < m; i++) {
		if (answ[i] != -1) continue;
		int best_f = -1;
		int cnt = -1;
		for (auto& f : free_friends[i]) {
			if (cnt == -1 || cnt_pick[f] < cnt) {
				cnt = cnt_pick[f];
				best_f = f;
			}
		}
		cnt_pick[best_f]++;
		answ[i] = best_f;
	}

	int targ = m / 2;
	if (m % 2 == 1) targ++;
	for (auto& elem : cnt_pick) {
		if (elem.second > targ) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
	for (auto& elem : answ) cout << elem << " ";
	cout << endl;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t = 0;
	cin >> t;
	for (int i = 0; i < t; i++) solution();
}

deft1
ostream& operator<<(ostream& out, vector<t1>& a) {
	if (a.size() == 0) out << "[]";
	else {
		out << "[" << a[0];
		for (int i = 1; i < a.size(); i++) {
			out << " " << a[i];
		}
		out << "]";
	}
	return out;
}
template<typename t1, typename t2>
ostream& operator<<(ostream& out, pair<t1, t2>& a) {
	out << "{ " << a.first << ", " << a.second << " }";
}
