// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;

#define int long long

#ifdef LOCAL
	const int N = (1 << 10);
#else
	const int N = (1 << 20);
#endif

struct Seg_tree {
	int t[2 * N + 228];
	int mod[2 * N + 228];
	Seg_tree(vector<int> a) {
		fill(t, t + 2 * N + 228, 0);
		fill(mod, mod + 2 * N + 228, 0);
		int n = a.size();
		for (int i = 0; i < n; ++i) {
			t[i + N] = a[i];
		}
		for (int i = N - 1; i > 0; --i) {
			t[i] = max(t[2 * i], t[2 * i + 1]);
		}
	}

	void push(int i) {
		if (i < N) {
			mod[2 * i] += mod[i];
			mod[2 * i + 1] += mod[i];
		}
		t[i] += mod[i];
		mod[i] = 0;
	}

	int get(int v, int tl, int tr, int l, int r) {
		push(v);
		if (l <= tl && tr <= r) return t[v];
		if (tl >= r || tr <= l) return 0;
		int m = (tl + tr) / 2;
		return max(get(2 * v, tl, m, l, r), get(2 * v + 1, m, tr, l, r));
	}

	void update(int v, int tl, int tr, int l, int r, int x) {
		if (l <= tl && tr <= r) {
			mod[v] += x;
			push(v);
			return;
		}
		push(v);
		if (tl >= r || tr <= l) return;
		int m = (tl + tr) / 2;
		update(2 * v, tl, m, l, r, x);
		update(2 * v + 1, m, tr, l, r, x);
		t[v] = max(t[2 * v], t[2 * v + 1]);
	}
};

signed main() {
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
		cout << fixed << setprecision(3);
	#else
		ios_base::sync_with_stdio(false);
		cin.tie(nullptr);
		cout.tie(nullptr);
		cout << fixed << setprecision(15);
	#endif
	int T;
	cin >> T;
	while (T --> 0) {
		int n, m;
		cin >> n >> m;
		vector<vector<int>> d(m);
		set<pair<int, int>> q;
		vector<int> cnt(n);
		for (int i = 0; i < m; ++i) {
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int x;
				cin >> x;
				--x;
				d[i].emplace_back(x);
			}
		}
		vector<int> p(m);
		iota(p.begin(), p.end(), 0);
		sort(p.begin(), p.end(), [&](int i, int j) {
			return d[i].size() < d[j].size();
		});
		vector<int> ans(m, -1);
		for (auto i : p) {
			// cout << i + 1 << ' ';
			int mn = -1;
			for (auto x : d[i]) {
				if (mn == -1 || cnt[x] < cnt[mn]) mn = x;
			}
			// cout << mn + 1 << '\n';
			++cnt[mn];
			ans[i] = mn;
		}
		if (*max_element(cnt.begin(), cnt.end()) > (m + 1) / 2 || *min_element(ans.begin(), ans.end()) == -1) {
			cout << "NO\n";
			continue;
		} else {
			cout << "YES\n";
			for (auto x : ans) cout << x + 1 << ' ';
			cout << '\n'; 
		}
	}
	#ifdef LOCAL
		cerr << "proc time: " << 1.0 * clock() / CLOCKS_PER_SEC << "s    ";
	#endif
	return 0;
}