#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define sz(v) (int)(v).size()

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> indexed_set;

const ll INF = ll(2e9) + 100100, LINF = ll(1e18) + 100100;
const double EPS = 1e-9, PI = atan2(0.0, -1.0);
const int MODS[] = {signed(1e9) + 7, signed(1e9) + 9, 998244353};
const int PS[] = {117, 239, signed(1e5) + 3, 177013};
const int MAXN = signed(1e5) + 100, MAXLOG = 20;

mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

inline void solve() {
    int n, m; cin >> n >> m;
    vector<vector<int>> d(n);
    vector<int> frd(m);
    
    for (int i = 0; i < m; ++i) {
        int k; cin >> k;
        frd[i] = k;

        while (k--) {
            int f; cin >> f;
            d[--f].push_back(i);
        }
    }

    for (int i = 0; i < n; ++i) {
        sort(d[i].begin(), d[i].end(), [&](const int &a, const int &b) {
            return frd[a] < frd[b];
        });
    }

    vector<int> ans(m, -INF);
    vector<bool> used(m, false);
    int limit = (m + 1) / 2;

    for (int i = 0; i < n; ++i) {
        int taken = 0;

        for (auto j : d[i]) {
            if (taken == limit) break;
            if (used[j]) continue;
            ++taken;
            used[j] = true;
            ans[j] = i;
        }
    }

    for (int i = 0; i < m; ++i) {
        if (!used[i]) {
            cout << "NO\n";
            return;
        }
    }

    cout << "YES\n";
    for (auto i : ans) cout << i + 1 << " ";
    cout << "\n";
}

signed main() {
    fastio;
#ifdef hikki
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int q; cin >> q;
    while (q--) solve();

    return 0;
}