#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;

mt19937 rnd(time(0));

#define all(x) (x).begin(),(x).end()
#define ld long double
#define int long long

struct SparceTable {
    int n;
    vector<int> pows;
    vector<vector<int>> ST;
    SparceTable(vector<int> a1) {
        n = a1.size();
        pows.resize(n + 1, 0);
        for (int i = 2; i <= n; ++i) pows[i] = pows[i / 2] + 1;
        ST.resize(pows[n] + 1, vector<int> (n));
        for (int i = 0; i < n; ++i) ST[0][i] = a1[i];
        for (int p = 1; p <= pows[n]; ++p) {
            for (int i = 0; i < n; ++i) {
                ST[p][i] = min(ST[p - 1][i], ST[p - 1][min(i + (1 << (p - 1)), n - 1)]);
            }
        }
    }
    int getMin(int l, int r) {
        int len = r - l + 1;
        int p = pows[len];
        return min(ST[p][l], ST[p][r - (1 << p) + 1]);
    }
};

bool cmp(pair<int, vector<int>> &a, pair<int, vector<int>> &b) {
    return a.second.size() < b.second.size();
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), nxt(n), prev(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        nxt[i] = (i + 1) % n;
        prev[i] = (i + n - 1) % n;
    }
    vector<int> res;
    deque<int> dq;
    set<int> removed;
    for (int i = 0; i < n; ++i) dq.push_back(i);
    while (dq.size()) {
        int i = dq.front();
        dq.pop_front();
        if (removed.count(i)) continue;
        if (__gcd(a[i], a[nxt[i]]) == 1) {
            res.push_back(nxt[i]);
            removed.insert(nxt[i]);
            nxt[i] = nxt[nxt[i]];
            dq.push_back(i);
        }
    }
    cout << res.size() << ' ';
    for (auto& i : res) {
        cout << i + 1 << ' ';
    }
    cout << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
}