//#pragma GCC optimize("Ofast,no-stack-protector")
//#pragma GCC optimize("unroll-loops,rename-registres")

#include <iostream>
#include <cmath>
#include <algorithm>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <chrono>
#include <bitset>
#include <iomanip>
#include <numeric>
#include <queue>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

const ll INF = 1e15;
const ld pi = atan2(0, -1);
const ll mod = 998'244'353;
const ll P = 179, Q = 239;
const ll A = 26;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

ll sign(ll x) {
	if (x < 0) return -1;
	if (x == 0) return 0;
	return 1;
}

inline bool maxi(ll &a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

inline bool mini(ll &a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

inline ll add(ll a, ll b) {
	a += b;
	if (a >= mod) {
		a -= mod;
	}
	return a;
}

inline ll sub(ll a, ll b) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
	return a;
}

inline void addl(ll &a, ll b) {
	a += b;
	if (a >= mod) {
		a -= mod;
	}
}

inline void subl(ll &a, ll b) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
}

inline ll mul(ll a, ll b) {
	return (a * b) % mod;
}

inline void mull(ll &a, ll b) {
	a = (a * b) % mod;
}

ll n, m;
ll k;
ll q;

ll gcd(ll a, ll b) {
	if (!b) return a;
	return gcd(b, a % b);
}

struct node {
	ll key, ind;
	node *l, *r;

	node(ll key = 0, ll ind = 0) : key(key), ind(ind), l(nullptr), r(nullptr) {};
};

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	ll beg = clock();

	ll t;
	cin >> t;
	while (t--) {
		cin >> n;
		vector <node*> a(n);
		for (int i = 0; i < n; ++i) {
			a[i] = new node();
			cin >> a[i]->key;
			a[i]->ind = i;
		}
		for (int i = 0; i < n; ++i) {
			ll j = (i + 1) % n;
			ll k = (i - 1 + n) % n;
			a[i]->r = a[j];
			a[i]->l = a[k];
		}
		vector <ll> ans;
		queue <ll> q;
		for (int i = 0; i < n; ++i) {
			ll j = (i + 1) % n;
			if (gcd(a[i]->key, a[j]->key) == 1) {
				q.push(i);
			}
		}
		vector <bool> used(n, false);
		ll left = n;
		while (!q.empty()) {
			ll cur = q.front();
//			cout << "Processing ";
//			cout << cur << '\n';
			q.pop();
			if (used[cur]) continue;
			if (gcd(a[cur]->key, a[cur]->r->key) == 1) {
				ans.push_back(a[cur]->r->ind);
				used[a[cur]->r->ind] = true;
//				cout << "Erased " << a[cur]->r->ind << '\n';
				--left;
				if (!left) break;
				a[cur]->r = a[cur]->r->r;
				a[cur]->r->l = a[cur];
				if (gcd(a[cur]->key, a[cur]->r->key) == 1) {
					q.push(a[cur]->ind);
				}
			}
		}
		cout << ans.size() << ' ';
		for (auto &x : ans) {
			cout << x + 1 << ' ';
		}
		cout << '\n';
	}

	cerr << "Process terminated in " << (clock() - beg) * 1.0l / CLOCKS_PER_SEC << "s\n";
	return 0;
}
/*
100
16
1 2 3 5 7 11 13 17 19 23 29 31 37 41 43 47
*/