#ifdef MANSON
#define BUGO(x) cerr << #x << "->" << (x) << endl;
#define BUGOARR(a) {cerr << #a << "->{ "; for (auto i: a) cerr << i << ' '; cerr << "}" << endl;}
#else
#define BUGO(x) ;
#define BUGOARR(a) {}
#endif
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <list>
#include <set>
using namespace std;
using llong = long long;
ostream& operator<<(ostream& out, const pair<int, int>& p) {
    return out << '{' << p.first << ", " << p.second << '}';
}
const int maxN = 100'000;

int n;
int a[2 * maxN], upto[maxN], from[maxN];
int prv[4 * maxN], nxt[4 * maxN], tol[4 * maxN], tor[4 * maxN];

void Set(int* t, int v, int vl, int vr, int l, int r, int val)
{
    if (t[v] == -69) {
        t[v] = -1;
        if (vl != vr)
            t[v * 2] = t[v * 2 + 1] = -69;
    }
    if (l > vr || vl > r) return;
    if (l <= vl && vr <= r) {
        t[v] = val;
        return;
    }
    int vm = (vl + vr) / 2;
    t[v] = -1;
    Set(t, v * 2, vl, vm, l, r, val);
    Set(t, v * 2 + 1, vm + 1, vr, l, r, val);
}
int Get(int* t, int v, int vl, int vr, int i)
{
    if (t[v] == -69) {
        t[v] = -1;
        if (vl != vr)
            t[v * 2] = t[v * 2 + 1] = -69;
    }
    if (t[v] != -1 || vl == vr) return t[v];
    int vm = (vl + vr) / 2;
    if (i <= vm) return Get(t, v * 2, vl, vm, i);
    return Get(t, v * 2 + 1, vm + 1, vr, i);
}
void Set(int* t, int l, int r, int val)
{
    while (l < 0) l += n, r += n;
    while (l >= n) l -= n, r -= n;
    if (r < n)
        Set(t, 1, 0, n - 1, l, r, val);
    else {
        Set(t, 1, 0, n - 1, l, n - 1, val);
        Set(t, n, r, val);
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        prv[1] = nxt[1] = tol[1] = tor[1] = -69;
        cin >> n;
        for (int i = 0; i < n; ++i)
            cin >> a[i], a[n + i] = a[i];
        vector<int> ans;
        int i = n;
        while (i && __gcd(a[i % n], a[i - 1]) > 1) --i;
        if (i == 0) {
            cout << "0\n";
            continue;
        }
        else if (i == n)
            i = 0;
        struct Hrashq {
            int x, ind;
            operator int() { return x; }
        };
        list<list<Hrashq>> b;
        int j = i;
        do {
            if (j == i || __gcd(a[j], a[(j - 1 + n) % n]) == 1)
                b.push_back(list<Hrashq>());
            b.back().push_back({a[j], j + 1});
            j = (j + 1) % n;
        } while (j != i);
        auto it = b.begin();
        while (true)
        {
            /*BUGO(b.size())
            for (auto h: b)
                BUGOARR(h)*/
            if (b.size() == 1)
            {
                if (__gcd(it->front().x, it->back().x) > 1)
                    break;
            }
            else if (++it == b.end())
                it = b.begin();
            ans.push_back(it->front().ind);
            it->pop_front();
            if (it->empty()) {
                if (b.size() == 1) break;
                it = b.erase(it);
                if (it == b.end())
                    it = b.begin();
                if (b.size() > 1)
                {
                    auto prv = (it == b.begin()) ? prev(b.end()) : prev(it);
                    // BUGO(prv->back().x)
                    // BUGO(it->front().x)
                    if (__gcd(prv->back().x, it->front().x) > 1) {
                        if (it->size() < prv->size()) {
                            prv->insert(prv->end(), it->begin(), it->end());
                            it->swap(*prv);
                        }
                        else
                            it->insert(it->begin(), prv->begin(), prv->end());
                        b.erase(prv);
                    }
                }
            }
            else if (b.size() > 1)
            {
                auto prv = (it == b.begin()) ? prev(b.end()) : prev(it);
                // BUGO(prv->back().x)
                // BUGO(it->front().x)
                if (__gcd(prv->back().x, it->front().x) > 1) {
                    if (it->size() < prv->size()) {
                        prv->insert(prv->end(), it->begin(), it->end());
                        it->swap(*prv);
                    }
                    else
                        it->insert(it->begin(), prv->begin(), prv->end());
                    b.erase(prv);
                }
            }
        }
        cout << ans.size() << ' ';
        for (int i: ans) cout << i << ' ';
#ifdef MANSON
        cout << endl;
#else
        cout << '\n';
#endif
        /*upto[n - 1] = n - 1;
        while (upto[n - 1] + 1 != n + n - 1 && __gcd(a[upto[n - 1]], a[upto[n - 1] + 1]) > 1)
            ++upto[n - 1];
        for (int i = n - 2; i >= 0; --i)
            if (__gcd(a[i], a[i + 1]) == 1)
                upto[i] = i;
            else
                upto[i] = (upto[i + 1] == n + i ? n + i - 1 : upto[i + 1]);
        from[0] = 0;
        while (from[0] - 1 != -n && __gcd(a[(from[0] + n) % n], a[(from[0] - 1 + n) % n]) > 1)
            --from[0];
        for (int i = 1; i < n; ++i)
            if (__gcd(a[i], a[i - 1]) == 1)
                from[i] = i;
            else
                from[i] = (from[i - 1] == i - n ? i + 1 - n : upto[i - 1]);
        for (int i = 0; i < n; ++i) {
            Set(prv, 1, 0, n - 1, i, i, i - 1);
            Set(nxt, 1, 0, n - 1, i, i, i + 1);
            Set(tor, 1, 0, n - 1, i, i, upto[i]);
            Set(tol, 1, 0, n - 1, i, i, from[i]);
        }

        static vector<int> ans; ans.clear();
        int i = 0;
        while (ans.size() < n - 1)
        {
            {
                int j = i;
                cerr << a[j] << ' ';
                while (Get(nxt, 1, 0, n - 1, j) % n != i)
                    cerr << a[j = Get(nxt, 1, 0, n - 1, j) % n] << ' ';
                cerr << endl;
            }
            i = Get(tor, 1, 0, n - 1, i) % n;
            BUGO(i)
            int del = Get(nxt, 1, 0, n - 1, i) % n;
            int tch = Get(nxt, 1, 0, n - 1, del);
            int prvdel = Get(prv, 1, 0, n - 1, del);
            int nxtdel = Get(nxt, 1, 0, n - 1, del);
            BUGO(del)
            BUGO(prvdel)
            if (__gcd(a[prvdel], a[del]) > 1)
                break;
            int l = Get(tol, 1, 0, n - 1, del);
            int r = Get(tor, 1, 0, n - 1, del);
            BUGO(nxtdel)
            BUGO(l)
            BUGO(r)
            BUGO(tch)
            if (l != del)
                Set(tor, l, prvdel, prvdel);
            Set(nxt, 1, 0, n - 1, prvdel, prvdel, nxtdel);
            if (r != del)
                Set(tol, nxtdel, r, nxtdel);
            Set(prv, 1, 0, n - 1, nxtdel, nxtdel, prvdel);
            ans.push_back(del + 1);
            i = tch;
            for (int y = 0; y < n; ++y)
            {
                BUGO(y)
                BUGO(Get(prv, 1, 0, n - 1, y))
                BUGO(Get(nxt, 1, 0, n - 1, y))
                BUGO(Get(tol, 1, 0, n - 1, y))
                BUGO(Get(tor, 1, 0, n - 1, y))
            }
        }
        cout << ans.size() << ' ';
        for (int i: ans) cout << i << ' ';*/
    }
}
