#include <bits/extc++.h>

using namespace std;

//#define int ll

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef vector<int> vi;
typedef pair<int, int> pi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define sz(a) int((a).size())
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define forn(i, n) for (int i = 0; i < (n); i++)

mt19937 rnd(2342309423);

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    ios_base::sync_with_stdio();
#endif
    cout.setf(ios::fixed);
    cout.precision(10);
}

struct DSU {
    vi p;

    DSU(int n) {
        p.resize(n);
        iota(all(p), 0);
    }

    int Find(int a) {
        return p[a] == a ? a : p[a] = Find(p[a]);
    }

    void Del(int a, int b) {
        assert(p[a] == a);
        b = Find(b);
        p[a] = b;
    }
};

void Solve() {
    int n;
    cin >> n;
    vi a(n);
    for (auto &i : a)
        cin >> i;
    queue<pair<int, int>> q;
    for (int i = 0; i < n; i++) {
        q.emplace(i, (i + 1) % n);
    }
    vector<bool> alive(n, true);
    vi ans;
    DSU d(n);
    while (!q.empty()) {
        auto[f, s] = q.front();
        q.pop();
        int g = gcd(a[f], a[s]);
        if (!alive[f])
            continue;
        if (!alive[s]) {
            s = d.Find(s);
        }
        if (g == 1) {
            ans.emplace_back(s);
            d.Del(s, (s + 1) % n);
            alive[s] = false;
            q.emplace(f, d.Find(s));
        }
    }
    cout << ans.size() << ' ';
    for (auto& i : ans)
        cout << i + 1 << ' ';
    cout << nl;
}

signed main() {
    IO();
    int t = 1;
    cin >> t;
    for (int i = 0; i < t; i++) {
        Solve();
    }
    return 0;
}
