#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

#define int int32_t
#define ll int64_t

#define uint uint32_t
#define ull uint64_t

#define many_tests

void ios() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

int gcd(int a, int b) {
    if (a < b) std::swap(a, b);
    while (b != 0) {
        a %= b;
        std::swap(a, b);
    }
    return a;
}

struct node {
    int l;
    int r;
};

std::set<int> exist;

int getNext(int i) {
    auto it = exist.upper_bound(i);
    if (it == exist.end()) it = exist.begin();
    return *it;
}

void solve() {
    int n;
    std::cin >> n;
    exist.clear();
    std::vector<int> a(n), l(n), r(n);
    std::vector<node> g(n);
    std::set<int> nulls;
    for (int i = 0; i < n; ++i) {
        std::cin >> a[i];
        g[i] = {i, (i + 1) % n};
        l[i] = i;
        r[(i + 1) % n] = i;
        exist.insert(i);
    }

    for (int i = 0; i < n; ++i) {
        if (gcd(a[i], a[(i + 1) % n]) == 1) {
            nulls.insert(i);
        }
    }
    int pos = 0;
    std::vector<int> ans;
    while (!nulls.empty() && !exist.empty()) {
        auto it = nulls.lower_bound(pos);
        if (it == nulls.end()) {
            it = nulls.begin();
        }
        int ind = *it;
        nulls.erase(it);
        nulls.erase(l[g[ind].r]);
        exist.erase(g[ind].r);
        ans.push_back(g[ind].r);
        g[ind].r = getNext(g[ind].r);
        r[g[ind].r] = ind;
        if (gcd(a[g[ind].l], a[g[ind].r]) == 1) nulls.insert(ind);
        pos = ind + 2;
    }
    std::cout << ans.size() << ' ';
    for (auto &elem : ans) std::cout << elem + 1 << ' ';
    std::cout << '\n';
}

int main() {
    ios();
#ifdef many_tests
    int ttt;
    std::cin >> ttt;
    while (ttt-- > 0) {
        solve();
    }
#else
    solve();
#endif
    return 0;
}