#include <iostream>
#include <map>
#include <algorithm>
#include <queue>
#include <set>
#include <cstring>
#include <unordered_map>
#include <unordered_set>
#include <vector>
#include <random>
#include <iomanip>
#include <cassert>
#include <bitset>
#include <deque>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double

using namespace std;

mt19937 rnd(time(nullptr));

inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int gcd(int a, int b) {
    while (b) {
        a %= b;
        swap(a, b);
    }
    return a;
}

const int inf = 2e9 + 123;

struct segtree {
    segtree *l = nullptr, *r = nullptr;
    int lb, rb;
    int val;
    segtree() {}
    void pull() {
        val = l->val + r->val;
    }
    segtree(int L, int R, const vector<int> &v) {
        lb = L, rb = R;
        if (lb + 1 == rb) {
            val = (v[lb] == 1);
        } else {
            int m = (lb + rb) / 2;
            l = new segtree(lb, m, v);
            r = new segtree(m, rb, v);
            pull();
        }
    }
    void upd(int ind, int x) {
        if (lb + 1 == rb) {
            val = (x == 1);
        } else {
            int m = (lb + rb) / 2;
            if (ind < m) {
                l->upd(ind, x);
            } else {
                r->upd(ind, x);
            }
            pull();
        }
    }
    int get(int L, int R) {
        if (L >= rb || lb >= R) return 0;
        if (L <= lb && R >= rb) {
            return val;
        }
        return l->get(L, R) + r->get(L, R);
    }
    int spusk(int x) { // sum >= x
        if (val < x) return rb;
        if (lb + 1 == rb) return lb;
        if (l->val >= x) {
            return l->spusk(x);
        } else {
            return r->spusk(x - l->val);
        }
    }
};

segtree *root = nullptr;

int n;

int nxt(int x) {
    int sum = root->get(0, x + 1);
    int anss = root->spusk(sum + 1);
    if (anss == n) {
        anss = root->spusk(1);
        if (anss == n) {
            return -1;
        }
    }
    return anss;
}

void print() {
    for (int i = 0; i < n; ++i) {
        cout << root->get(i, i + 1) << ' ';
    }
    cout << '\n';
}

void solve() {
    cin >> n;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }
    vector<int> g(n);
    for (int i = 0; i < n; ++i) {
        g[i] = gcd(v[(i + 1) % n], v[i]);
    }
    root = new segtree(0, n, g);
    set<int> now;
    now.clear();
    set<int> noww;
    noww.clear();
    for (int i = 0; i < n; ++i) {
        now.insert(i);
        noww.insert(-i);
    }
    auto nxtt = [&] (int x) {
        auto it = now.upper_bound(x);
        if (it == now.end()) {
            it = now.begin();
        }
        return *it;
    };

    auto prv = [&] (int x) {
        auto it = noww.upper_bound(-x);
        if (it == noww.end()) {
            it = noww.begin();
        }
        return -(*it);
    };

//    print();

    vector<int> answer;
    int position = -1;
    for (int i = 0; i < n; ++i) {
        int pos = nxt(position);
        if (pos == -1) break;
        pos = nxtt(pos);
        answer.push_back(pos);
        root->upd(pos, inf);
        int before = prv(pos);
        int nex = nxtt(pos);
        root->upd(before, gcd(v[before], v[nex]));
        now.erase(pos);
        noww.erase(-pos);
        position = pos;
//        print();
    }
    cout << (int) answer.size() << ' ';
    for (auto i : answer) {
        cout << i + 1 << ' ';
    }
    cout << '\n';
}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}