#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

const long long INF = 1e16;

vector<ll> t;

void build(int v, vector<ll>& a, int l, int r)
{
    if (l == r)
    {
        if (a[l] == 1)
            t[v] = l;
        else
            t[v] = -1;
    }
    else
    {
        int m = (l + r) / 2;
        build(v * 2, a, l, m);
        build(v * 2 + 1, a, m + 1, r);
        if (t[v * 2] != -1)
            t[v] = t[v * 2];
        else
            t[v] = t[v * 2 + 1];
    }
}

int get(int v, int l, int r, int ql, int qr)
{
    if (ql > qr)
        return -1;
    else if (l == ql && r == qr)
        return t[v];
    else
    {
        int m = (l + r) / 2;
        int left = get(v * 2, l, m, ql, min(qr, m));
        int right = get(v * 2 + 1, m + 1, r, max(ql, m + 1), qr);
        if (left != -1)
            return left;
        else
            return right;
    }
}

void update(int v, int l, int r, int pos, ll x)
{
    if (l == r)
    {
        if (x == 1)
            t[v] = l;
        else
            t[v] = -1;
    }
    else
    {
        int m = (l + r) / 2;
        if (pos <= m)
            update(v * 2, l, m, pos, x);
        else
            update(v * 2 + 1, m + 1, r, pos, x);

        if (t[v * 2] != -1)
            t[v] = t[v * 2];
        else
            t[v] = t[v * 2 + 1];
    }
}

ll gcd(ll a, ll b)
{
    if (a == 0)
        return b;
    else
        return gcd(b % a, a);
}

void solve()
{
    int n;
    cin >> n;
    t.resize(n * 4);
    vector<ll> a(n);
    vector<int> next(n);
    int SIZE = n;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        next[i] = (i + 1) % n;
    }
    vector<ll> b(n);

    for (int i = 0; i < n; i++)
        b[i] = gcd(a[i], a[(i + 1) % n]);

    build(1, b, 0, n - 1);

    int start = 0;

    vector<int> out;

    while (1)
    {
        if (SIZE == 1)
            break;
        int ans = get(1, 0, n - 1, start, n - 1);
        if (ans == -1)
        {
            if (start == 0)
                break;
            else
                start = 0;
        }
        else
        {
            SIZE--;
            out.push_back(next[ans]);
            update(1, 0, n - 1, next[ans], 0);
            a[next[ans]] = 0;
            b[next[ans]] = 0;
            next[ans] = next[next[ans]];
            update(1, 0, n - 1, ans, gcd(a[ans], a[next[ans]]));
            b[ans] = gcd(a[ans], a[next[ans]]);
            start = next[ans];
        }
    }

    if (SIZE == 1)
    {
        for (int i = 0; i < n; i++)
        {
            if (a[i] == 1)
            {
                out.push_back(i);
                break;
            }
        }
    }

    cout << out.size() << " ";
    for (auto& x : out)
        cout << x + 1 << " ";
    cout << '\n';

    return;
}

int main()
{
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}