#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <time.h>
#include <math.h>
#include <fstream>
#define all(x) x.begin(), x.end()
#define mp make_pair
#define int ll

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 7, N = 3e5 + 6;

ll MOD(ll x) { x %= INF; if (x < 0) { x += INF; } return x; }

int gcd(int a, int b) {
	if (b == 0) { return a; }
	else { return gcd(b, a % b); }
}


ll n, m, k, t;
vector<int> to, skip;

int find(int x) {
	if (to[x] == x) {
		return x;
	}
	return to[x] = find(to[x]);
}

int next(int x) {
	if (skip[x] == x) {
		return x;
	}
	return skip[x] = next(skip[x]);
}



void solve() {
	cin >> n;

	to.clear();
	skip.clear();
	to.resize(n);
	skip.resize(n);
	vector<int> arr(n);
	vector<bool> used(n, true);

	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		to[i] = i;
		skip[i] = i;
	}

	int cnt = 0;

	for (int i = 0; i < n; i++) {
		int j = (i + 1) % n;
		if (gcd(arr[i], arr[j]) != 1) {
			to[i] = j;
			cnt++;
		}
	}

	if (cnt == n) {
		cout << 0 << '\n';
		return;
	}


	int i = 0, last = n;
	vector<int> er;

	while (last > 0) {
		i = find(i);
		
		int j = (i + 1) % n;

		j = next(j);
		er.push_back(j);
		used[j] = false;
		last--;
		if (last == 0) {
			break;
		}
		skip[j] = (j + 1) % n;

		j = (j + 1) % n;
		j = next(j);

		if (gcd(arr[i], arr[j]) != 1) {
			if (find(j) == i) {
				to[i] = j;
				break;
			}
			else {
				to[i] = j;
			}
		}
		i = j;
	}

	cout << er.size() << " ";

	for (int x : er) {
		cout << x + 1 << " ";
	}

	cout << '\n';


}





signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(NULL), cout.tie(NULL);
	
	cin >> t;
	while (t--) {
		solve();
	}

}

