#include <iostream>
#include <vector>
#include <deque>
using namespace std;

const int MAXN = 1e5 + 123;
int n;
int a[MAXN];
int nt[MAXN];
int pv[MAXN];

int gcd(int a, int b){
	if(!b)
		return a;
	return gcd(b, a % b);
}

int getnt(int i){
	if(i >= n)
		return n;
	if(nt[i] == i)
		return i;
	nt[i] = getnt(nt[i]);
	return nt[i];
}

int getpv(int i){
	if(i == -1)
		return -1;
	if(pv[i] == i)
		return i;
	pv[i] = getpv(pv[i]);
	return pv[i];
}

void solve(){
	cin >> n;
	for(int i = 0; i < n; i++)
		cin >> a[i], nt[i] = pv[i] = i;
	deque<int> eras;
	for(int i = 0; i + 1 < n; i++){
		if(gcd(a[i], a[i + 1]) == 1){
			eras.push_back(i + 1);
		}
	}
	if(gcd(a[0], a[n - 1]) == 1)
		eras.push_back(0);
	vector<int> ans;
	while(eras.size()){
		int i = eras.front();
		ans.push_back(i);
		if(ans.size() == n)
			break;
		nt[i] = (i + 1) % n;
		pv[i] = (n + i - 1) % n;
		getnt(i);
		getpv(i);
		eras.pop_front();

		if(eras.size() && eras.front() == nt[i]){
			eras.pop_front();
		}
		if(gcd(a[pv[i]], a[nt[i]]) == 1)
			eras.push_back(nt[i]);
	}
	cout << ans.size() << ' ';
	for(auto x : ans)
		cout << x + 1 << ' ';
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	int t;
	cin >> t;
	while(t--){
		solve();
		cout << '\n';
	}
}
