#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#define ll long long
using namespace std;

int t, n;
int inf = -1e9 - 100;

struct num {
    int val, prv, nxt;
};

int gcd(int a, int b){
    return (b == 0 ? a : gcd(b, a % b));
}

vector<int> tree;



void change(int v, int l, int r, int val, int pos){
    if(r - l == 1){
        tree[v] = val;
        return;
    }
    int m = (l + r) / 2;
    if(pos < m)
        change(2 * v + 1, l, m, val, pos);
    else
        change(2 * v + 2, m, r, val, pos);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void change(int pos, int val){
    change(0, 0, n, val, pos);
}

int sum(int v, int l, int r, int L, int R){
    if(r <= L || R <= l)
        return 0;
    if(L <= l && r <= R)
        return tree[v];
    int m = (l + r) / 2;
    return sum(2 * v + 1, l, m, L, R) + sum(2 * v + 2, m, r, L, R);
}

int sum(int l, int r){
    return sum(0, 0, n, l, r);
}

int find(int v, int l, int r, int f){
    if(r - l == 1)
        return l;
    int m = (l + r) / 2;
    if(tree[2 * v + 1] >= f)
        return find(2 * v + 1, l, m, f);
    return find(2 * v + 2, m, r, f - tree[2 * v + 1]);
}

int nearest(int l, int r){
    int s = sum(0, l);
    if(s == tree[0])
        return -1;
    return find(0, 0, n, s + 1);
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> t;
    while(t--){
        cin >> n;
        vector<int> ans;
        tree.assign(4 * n, 0);
        vector<num> a(n);
        for(int i = 0; i < n; i++) {
            cin >> a[i].val;
            a[i].prv = (i - 1 + n) % n;
            a[i].nxt = (i + 1) % n;
        }
        //cout << "Done" << endl;
        for(int i = 0; i < n; i++){
            if(gcd(a[i].val, a[(i + 1) % n].val) == 1){
                change(i, 1);
            }
        }
        int i = 0;
        while(tree[0] > 0){
            // [i, n)
            int tmp = nearest(i, n);
            if(tmp == -1){
                tmp = nearest(0, i);
            }

            if(a[tmp].nxt == tmp){
                ans.push_back(tmp + 1);
                break;
            }

            //cout << "tmp is " << tmp << endl;

            int erased = a[tmp].nxt;
            ans.push_back(erased + 1);

            change(0, 0, n, 0, tmp);
            change(0, 0, n, 0, erased);

            a[a[erased].nxt].prv = tmp;
            a[tmp].nxt = a[erased].nxt;

            if(gcd(a[tmp].val, a[a[tmp].nxt].val) == 1) {
                change(tmp, 1);
            }

            i = a[tmp].nxt;
        }
        cout << ans.size() << " ";
        for(int i : ans)
            cout << i << " ";
        cout << endl;
    }
}
