#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <bitset>
#include <tuple>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

ll bpow(ll a, ll p, ll md) {
	if (p == 0) return 1ll;
	if (p % 2) return (bpow(a, p - 1, md) * a) % md;
	ll b = bpow(a, p / 2, md);
	return (b * b) % md;
}

const ll SZ = 1e5 + 100, MOD = 1e9 + 7, INF = 1e9 * 1e9 + 100;

ll nxt[SZ];
ll dsu[SZ], sz[SZ];

ll find(ll v) {
	if (dsu[v] == v) return v;
	else return dsu[v] = find(dsu[v]);
}

void uni(int v, int u) { // v becomes parent
	v = find(v);
	u = find(u);
	if (v != u) {
		dsu[u] = v;
		nxt[v] = nxt[u];
	}
}

void sol() {
	ll n;
	cin >> n;
	vector<ll> vec(n);

	for (auto& c : vec) cin >> c;

	set<ll> st;

	for (int i = 0; i < n; i++) {
		dsu[i] = i;
		nxt[i] = (i + 1) % n;
		if (gcd(vec[i], vec[(i + 1) % n]) == 1) {
			st.insert(i);
		}
	}

	ll curInd = 0;
	vector<ll> ans;
	set<ll> usd;
	while (!st.empty()) {
		ll v;
		
		if (st.lower_bound(curInd) == st.end()) {
			v = (*st.begin());
		}
		else {
			v = (*st.lower_bound(curInd));
		}

		ans.push_back(nxt[find(v)]);
		st.erase(v);

		
		ll f = nxt[find(v)];
		if (usd.find(f) != usd.end()) continue;
		if (f == v) break;
		ll f2 = find(f);
		if (gcd(vec[f], vec[nxt[f2]]) == 1) {
			st.erase(f);
		}
		if (gcd(vec[v], vec[nxt[find(f)]]) == 1) {
			st.insert(v);
		}
		curInd = v + 1;
		curInd %= n;

		uni(v, f);
	}

	cout << ans.size() << " ";
	for (auto c : ans) cout << c + 1 << " ";

	cout << "\n";
}

int main() {
	fastInp;

	ll t;
	cin >> t;
	while (t--) {
		sol();
	}

	return 0;
}