#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

int gcd(int a, int b)
{
    if (b == 0)
        return a;
    else
        return gcd(b, a % b);
}

int main()
{
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while (t--)
    {
        int n;
        cin >> n;
        vector<int> a(n);
        for (int i = 0; i < n; i++)
        {
            cin >> a[i];
        }

        vector<int> last(n), nxt(n);
        for (int i = 0; i < n; i++)
        {
            if (i == 0)
                last[i] = n - 1;
            else
                last[i] = i - 1;
            if (i == n - 1)
                nxt[i] = 0;
            else
                nxt[i] = i + 1;
        }

        queue<int> q;
        int last_add = -1;
        for (int i = 1; i <= n; i++)
        {
            if (i == n && gcd(a[0], a[n - 1]) == 1)
            {
                q.push(0);
                last_add = 0;
            }
            if (i < n && gcd(a[i], a[i - 1]) == 1)
            {
                q.push(i);
                last_add = i;
                i++;
            }
        }

        vector<int> ans;
        int cur;
        while (!q.empty())
        {
            cur = q.front();
            ans.push_back(cur);
            q.pop();

            if (last[cur] != last_add && gcd(a[nxt[cur]], a[last[cur]]) == 1)
            {
                last_add = nxt[cur];
                q.push(last_add);
            }

            last[nxt[cur]] = last[cur];
            nxt[last[cur]] = nxt[cur];
        }

        cout << ans.size() << " ";
        for (int x : ans)
            cout << x + 1 << " ";
        cout << endl;
    }

    return 0;
}