﻿#include <iostream>
#include <iomanip>
#include <string>
#include <deque>
#include <vector>
#include <set>
#include <cmath>
#include <algorithm>
#include <assert.h>
#include <bitset>
#include <queue>
#include <stack>
#include <map>

using namespace std;
using ll = long long;
using ld = long double;
using ul = unsigned long long;

#define print(h) for (auto ijkl:h) cout << ijkl << " "; cout << "\n";
#define ve vector
#define vll ve <ll> 
#define pb push_back

vll par;

void init(ll n) {
	par.resize(n);
	for (int i = 0; i < n; ++i) {
		par[i] = i;
	}
}

ll find(ll a) {
	if (a == par[a]) return a;
	return par[a] = find(par[a]);
}

void merge(ll a, ll b) {
	if (find(a) != find(b)) {
		par[find(a)] = find(b);
	}
}

ll gcd(ll a, ll b) {
	if (b == 0) return a;
	return gcd(b, a % b);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll t;
	cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		vll a(n);
		vll ans;
		vll nex(n);
		for (int i = 0; i < n; ++i) {
			cin >> a[i];
			nex[i] = (i + 1) % n;
		}
		init(n);
		ll ind = 0;
		bool f = true;
		while (find(nex[ind]) != ind || gcd(a[ind], a[nex[ind]]) == 1)  {
			//print(ans);
			//cout << "ind :" <<ind << "\n";
			//print(nex);
			if (ind == nex[ind] && a[ind] == 1) {
				ans.pb(ind + 1);
				break;
			}
			ll id = nex[ind];
			if (gcd(a[ind], a[id]) == 1) {
				nex[ind] = nex[id];
				ans.pb(id + 1);
				ind = find(nex[id]);
			}
			else {
				merge(ind, id);
				ind = find(id);
			}

		}
		cout << ans.size() << " ";
		print(ans);
	}

	return 0;
}
