#include <iostream>
#include <vector>
#include <set>

using namespace std;

#define int long long
const int SZ = 1e5 + 4;

int n;
int a[SZ];

void read() {
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
}

int gcd(int a, int b) {
    while (b) {
        int c = a % b;
        a = b;
        b = c;
    }
    return a;
}

void solve() {
    set<int> s;
    for (int i = 0; i < n; ++i) {
        s.insert(i);
    }

    set<int> s1;
    for (int i = 0; i < n; ++i) {
        if (gcd(a[i], a[(i - 1 + n) % n]) == 1) {
            s1.insert(i);
        }
    }

    vector<int> ans;
    int cur = 0;
    for (int i = 0; i < n && !s1.empty(); ++i) {
        auto it = s1.upper_bound(cur);
        if (it == s1.end()) {
            it = s1.begin();
        }
        int x = *it;
        s1.erase(x);
        ans.push_back(x);
        s.erase(x);

        if (s.empty()) break;

        it = s.upper_bound(x);
        if (it == s.end()) {
            it = s.begin();
        }
        int upd = *it;
        cur = upd;

        s1.erase(upd);

        if (it == s.begin()) {
            it = --s.end();
        } else {
            --it;
        }

        int prev = *it;
        if (gcd(a[upd], a[prev]) == 1) {
            s1.insert(upd);
        }
    }

    cout << ans.size() << " ";
    for (int x : ans) {
        cout << x + 1 << " ";
    }
    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int t;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        read();
        solve();
    }

    return 0;
}