#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <iomanip>
#include <ctime>
#include <climits>
#include <unordered_set>
#include <queue>

using namespace std;

#pragma warning (disable : 4996)

int gcd(int a, int b) {
    if (a < b)
        swap(a, b);
    if (b == 0)
        return a;
    return gcd(b, a % b);
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int& i : v)
        cin >> i;
    vector<set<pair<int, int>>> p(n);
    set<pair<int, int>> used;
    queue<pair<int, int>> q;
    for (int i = 0; i < n; i++) {
        if (gcd(v[i], v[(i + 1) % n]) == 1) {
            p[i].insert({ i, (i + 1) % n });
            q.push({ i, (i + 1) % n });
        }
    }
    vector<int> ans;
    set<int> alive;
    for (int i = 0; i < n; i++)
        alive.insert(i);
    while (!q.empty()) {
        pair<int, int> del = q.front();
        q.pop();
        if (used.find(del) != used.end())
            continue;
        ans.push_back(del.second);
        alive.erase(del.second);
        if (alive.size() > 1) {
            for (auto p1 : p[del.second])
                used.insert(p1);
            auto it = alive.upper_bound(del.first);
            if (it == alive.end())
                it = alive.begin();
            if (gcd(v[del.first], v[*it]) == 1) {
                p[del.first].insert({ del.first, *it });
                q.push({ del.first, *it });
            }
        }
        else {
            if (v[del.first] == 1 && del.second != del.first)
                ans.push_back(del.first);
            break;
        }
    }
    cout << ans.size() << " ";
    for (int i : ans)
        cout << i + 1 << " ";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
    return 0;
}