#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>

#include "ext/rope"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"
#include <ctime>

#ifndef LOCAL_BUILD
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#endif

namespace {
    using namespace std;
    using namespace __gnu_cxx;
    using namespace __gnu_pbds;
    
    typedef long long ll;
    typedef long double ld;
    
    typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update, allocator<char>> ordered_set;
    
    const int MOD = 1e9 + 7;
    const int INF = 1e9 + 33;
    const ll LLINF = 1e18 + 11;
    const ld EPS = 1e-8;

#define speed ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
    
    template<typename T>
    istream& operator>>(istream& in, vector<T>& r) {
        for (auto& e : r)
            cin >> e;
    }
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {
        cin >> p.first >> p.second;
    }
    
    template<typename T>
    ostream& operator<<(ostream& out, vector<T>& r) {
        for (auto& e : r)
            cout << e << ' ';
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("test.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
//    speed;
    int t; cin >> t; while (t--)
    solve();
}

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    cin >> a;
    vector<int> ans;
//    for (; uncheckedCnt != 0; idx = (idx + 1) % n) {
//        if (skipped[idx])
//            continue;
//        if (!unchecked[idx])
//        unchecked[idx] = false;
//        uncheckedCnt--;
//        int gcd = __gcd(prev, a[idx]);
//        if (gcd != 1) {
//            prev = a[idx];
//            continue;
//        }
//        ans.push_back(idx + 1);
//        skipped[idx] = true;
//        unchecked[(idx + 1) % n] = true;
//        prev = 0;
//    }
    set<int> available;
    for (int i = 0; i < n; i++)
        available.insert(i);
    
    deque<pair<int, int>> intros;
    for (int i = 0; i < n; i++) {
        intros.emplace_back(i, (i + 1) % n);
    }
    vector<bool> skipped(n, false);
    
    while (!intros.empty()) {
        auto p = intros.front();
        intros.pop_front();
        int previ = p.first, idx = p.second;
        if (skipped[previ])
            continue;
        int prev = a[previ];
        int gcd = __gcd(prev, a[idx]);
        if (gcd != 1) {
            continue;
        }
        ans.push_back(idx + 1);
        available.erase(idx);
        skipped[idx] = true;
        auto itnex = available.upper_bound(idx);
        int nex = 0;
        if (itnex != available.end()) {
            nex = *itnex;
        } else if (available.size() == 1)
            break;
        else
            nex = *available.begin();
        intros.emplace_back(previ, nex);
    }
    if (available.size() == 1 && a[*available.begin()] == 1) {
        ans.push_back(*available.begin() + 1);
    }
    cout << ans.size() << ' ';
    for (int e : ans)
        cout << e << ' ';
    cout << '\n';
}