#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <math.h>
#include <cmath>
#include <assert.h>
#include <queue>
#include <cstring>
#include <bitset>
#include <random>

using namespace std;

template<typename T> void uin(T &a, T b) {
    if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
    if (b > a) a = b;
}

#define int long long
#define next next288
#define left left228
#define right right228

const int N = 300 * 1000 + 228;
const int INF = 1e17 + 228;

struct node
{
    int mx;
    int l, r;
    node() {
        mx = l = r = 0;
    }
};

vector< node > d;

void build(int l, int r, int v = 1) {
    d[v].l = l;
    d[v].r = r;
    if (l == r) {

    } else {
        int m = (l + r) / 2;
        build(l, m, v * 2);
        build(m + 1, r, v * 2 + 1);
        d[v].mx = max(d[v * 2].mx, d[v * 2 + 1].mx);
    }
}

void init(int n) {
    int ss = 1;
    while (ss < n) ss <<= 1;
    ss <<= 1;
    d.resize(ss + 3, node());
    build(0, n);
}

void update(int i, int x, int v = 1) {
    if (d[v].l == d[v].r) {
        d[v].mx = x;
    } else {
        int m = (d[v].l + d[v].r) / 2;
        if (i <= m) {
            update(i, x, v * 2);
        } else {
            update(i, x, v * 2 + 1);
        }
        d[v].mx = max(d[v * 2].mx, d[v * 2 + 1].mx);
    }
}

int get_max(int l, int r, int v = 1) {
    if (l > r || d[v].l > r || d[v].r < l) return -INF;
    if (l <= d[v].l && d[v].r <= r) {
        return d[v].mx;
    }
    return max( get_max(l, r, v * 2), get_max(l, r, v * 2 + 1) );
}

int n;
int dp[N];
int left[N];
int h[N], b[N];

void calcLeft() {
    for (int i = 1; i <= n; ++i) {
        left[i] = 0;
    }
    vector<int> st;

    for (int i = n; i >= 1; --i) {
        while (!st.empty() && h[st.back()] > h[i]) {
            left[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }

}

void solve() {
    calcLeft();
    init(n + 1);

    for (int i = 0; i <= n; ++i) {
        dp[i] = -INF;
        update(i, -INF);
    }


    dp[0] = 0;
    update(0, 0);

    for (int i = 1; i <= n; ++i) {
        dp[i] = get_max(left[i], i - 1) + b[i];
        if (left[i] != 0) {
            dp[i] = max(dp[i], dp[left[i]]);
        }

        update(i, dp[i]);
    }


    cout << dp[n] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> h[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> b[i];
    }

    solve();

    return 0;
}