#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<utility>
#include<iomanip>
#include<cmath>
#include<algorithm>
#include<climits>
#include<vector>
#include<string>
#include<map>
#include<set>
#include<random>
#include <cassert>
#include <queue>
using namespace std;
#define int long long
mt19937 azino(777);
struct fenwick {
	vector<int> f;
	int n;
	void add(int i, int val) {
		for (; i < n; i |= (i + 1)) f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i) {
			ans += f[i];
		}
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
	fenwick(vector<int> a) {
		n = a.size();
		f.assign(n, 0);
		for (int i = 0; i < n; ++i) {
			add(i, a[i]);
		}
	}
	fenwick(int _n) {
		n = _n;
		f.assign(n, 0);
	}
};
int N = 3e5;
vector<int> t(N * 4 + 10);
void add(int ind, int val, int v = 1, int tl = 0, int tr = N - 1) {
	if (tl == tr) {
		t[v] = val;
		return;
	}
	int m = (tl + tr) >> 1;
	if (ind <= m) add(ind, val, v * 2, tl, m);
	else add(ind, val, v * 2 + 1, m + 1, tr);
	t[v] = max(t[v * 2], t[v * 2 + 1]);
}
int getmax(int l, int r, int v = 1, int tl = 0, int tr = N - 1) {
	if (tl > r || tr < l) return -1e18;
	if (tl >= l && tr <= r) return t[v];
	int m = (tl + tr) >> 1;
	return max(getmax(l, r, v * 2, tl, m), getmax(l, r, v * 2 + 1, m + 1, tr));
}
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int n;
	cin >> n;
	vector<int> h(n + 1), b(n + 1), d(n + 1, -1e18);
	for (int i = 0; i < n; ++i) {
		cin >> h[i + 1];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i + 1];
	}
	h[0] = -1;
	d[0] = 0;
	vector<int> st;
	st.push_back(0);
	for (int i = 1; i <= n; ++i) {
		d[i] = d[i - 1] + b[i];
		while (!st.empty() && h[st.back()] >= h[i]) {
			st.pop_back();
		}
		if (st.back() == 0) d[i] = max(d[i], b[i]);
		else d[i] = max(d[i], d[st.back()]);
		d[i] = max(d[i], getmax(st.back() + 1, i - 1) + b[i]);
		st.push_back(i);
		add(i, d[i]);
	}
	cout << d[n];
	return 0;
}