#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define pll pair<ll, ll>

const ll mod1 = 1e9 + 7;
const ll inf = 1e18;


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


ll rnd(ll a, ll b) {
    uniform_int_distribution<ll> r(a, b);
    return r(rng);
}


struct stree {
    vector<ll> t;
    ll flg;

    stree(int n, ll val) {
        t.resize(4 * n, val);
        flg = val;
    }

    ll get(int v, int l, int r, int ql, int qr) {
        if (l > qr or r < ql) {
            return flg;
        }
        if (ql <= l and r <= qr) {
            return t[v];
        }
        int mid = (l + r) / 2;
        return max(get(v * 2, l, mid, ql, qr), get(v * 2 + 1, mid + 1, r, ql, qr));
    }

    void upd(int v, int l, int r, int pos, ll val) {
        if (l == r) {
            t[v] = val;
            return;
        }
        int mid = (l + r) / 2;
        if (pos <= mid) {
            upd(v * 2, l, mid, pos, val);
        } else {
            upd(v * 2 + 1, mid + 1, r, pos, val);
        }
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
};


void solve() {
    int n;
    cin >> n;
    vector<ll> h(n), pr(n);
    stree t(n, -1);
    for (int i = 0; i < n; i++) {
        cin >> h[i];
        h[i]--;
        pr[i] = t.get(1, 0, n - 1, 0, h[i]);
        t.upd(1, 0, n - 1, h[i], i);
    }
    vector<ll> b(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    vector<ll> dp(n + 1);
    stree dpKeeper(n + 1, -inf);
    dpKeeper.upd(1, 0, n, 0, 0);
    for (int i = 1; i <= n; i++) {
        ll res = -inf;
        if (pr[i - 1] > -1) {
            res = dp[pr[i - 1] + 1];
        }
        res = max(res, dpKeeper.get(1, 0, n, pr[i - 1] + 1, i - 1) + b[i - 1]);
//        for (int j = i; j > pr[i - 1] + 1; j--) {
//            res = max(res, dp[j - 1] + b[i - 1]);
//        }
        dp[i] = res;
        dpKeeper.upd(1, 0, n, i, dp[i]);
    }
    cout << dp.back();
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
