#include <vector>
#include <algorithm>
#include <iostream>
#include <stack>
#include <set>

using namespace std;

#define int long long
const int maxn = 3e5 + 7;
const int INF = 1e15;
int t[4 * maxn];

void build(int v, int tl, int tr) {
    if (tl + 1 == tr) {
        t[v] = -INF;
        return;
    }
    int tm = (tl + tr) / 2;
    build(v * 2 + 1, tl, tm);
    build(v * 2 + 2, tm, tr);
    t[v] = t[v * 2 + 1];
}

void upd(int v, int tl, int tr, int pos, int val) {
    if (tl + 1 == tr) {
        t[v] = val;
        return;
    }
    int tm = (tl + tr) / 2;
    if (pos >= tm) {
        upd(v * 2 + 2, tm, tr, pos, val);
    } else {
        upd(v * 2 + 1, tl, tm, pos, val);
    }
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

int get(int v, int tl, int tr, int l, int r) {
    if (tl >= r || tr <= l) {
        return -INF;
    }
    if (l <= tl && tr <= r) {
        return t[v];
    }
    int tm = (tl + tr) / 2;
    return max(get(v * 2 + 1, tl, tm, l, min(r, tm)), get(v * 2 + 2, tm, tr, max(l, tm), r));
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> h, b;
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        h.push_back(x);
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        b.push_back(x);
    }
    build(0, 0, n);
    stack<pair<int, int>> st;
    set<pair<int, int>> cur;
    vector<int> dp(n, -INF);
    for (int i = 0; i < n; i++) {
        while (!st.empty() && h[i] <= st.top().first) {
            cur.erase(st.top());
            st.pop();
        }
        st.push({h[i], i});
        cur.insert(st.top());
        int prev = -INF, ind = -1;
        if (st.size() != 1) {
            auto it = cur.lower_bound({h[i], i});
            it--;
            ind = (*it).second;
            prev = dp[(*it).second];
        }
        dp[i] = prev;
        if (i == 0) {
            dp[i] = b[i];
        } else {
            int l = ind;
            if (l == -1) l =0;
            int val = get(0, 0, n, l, i);
            //cerr << val << " " << l << " " << i << '\n';

            dp[i] = max(dp[i], val + b[i]);
            if (ind == -1){
                dp[i] = max(dp[i], b[i]);
            }
        }
        //cerr << dp[i] << " ";
        //cerr << i << " " << b[i] << " " << t[0] << '\n';
        upd(0, 0, n, i, dp[i]);
    }
    cout << dp.back();
}