//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define mp std::make_pair
#define int long long

std::mt19937 myRandom(clock());

template<class T>
T mx(T &l, const T &r) {
    if (r > l) l = r;
    return l;
}

template<class T>
T mn(T &l, const T &r) {
    if (r < l) l = r;
    return l;
}

const ll inf = 0x3f3f3f3f3f3f3f3f;

const int MAXN = 3e5;
class SegmentTree {
private:
    int sz = 2 * MAXN;
    int tree[4 * MAXN];
public:
    SegmentTree() { for(auto &i : tree) i = -(inf); }

    void upd(int v, int newVal) {
        v += sz;
        tree[v] = newVal;
        v /= 2;
        while(v > 0) {
            tree[v] = std::max(tree[2 * v], tree[2 * v + 1]);
            v /= 2;
        }
    }

    int get(int l, int r) {
        l += sz, r += sz;
        int ans = -(inf);
        while(l < r) {
            if(l & 1) mx(ans, tree[l]);
            if(!(r & 1)) mx(ans, tree[r]);
            l = (l + 1) / 2;
            r = (r - 1) / 2;
        }
        if(l == r) mx(ans, tree[l]);
        return ans;
    }
};

int32_t main() {
    std::ios::sync_with_stdio(0), std::cin.tie(0);

    SegmentTree st;

    int n;
    std::cin >> n;
    int h[n], b[n];
    for (auto &i : h) std::cin >> i;
    for (auto &i : b) std::cin >> i;

    std::stack<int> sta;
    int nearestLeftSmaller[n];
    memset(nearestLeftSmaller, -1, sizeof(nearestLeftSmaller));
    for(int i = 0; i < n; i++) {
        while(!sta.empty() && h[sta.top()] > h[i]) sta.pop();
        if(!sta.empty()) nearestLeftSmaller[i] = sta.top();
        sta.push(i);
    }

    int dp[n];
    memset(dp, 0, sizeof(dp));
    dp[0] = b[0];
    st.upd(0, b[0]);
    for (int i = 1; i < n; i++) {
        int left = nearestLeftSmaller[i];
        if(left == -1) {
            dp[i] = b[i] + st.get(0, i);
            mx(dp[i], b[i]);
            st.upd(i, dp[i]);
            continue;
        }
        dp[i] = dp[left];
        mx(dp[i], b[i] + st.get(left, i - 1));

        st.upd(i, dp[i]);
    }

    std::cout << dp[n - 1] << '\n';
}
