#include<bits/stdc++.h>

using namespace std;

//#define int long long

using ll = long long;

namespace {
    template<typename T>
    ostream &operator<<(ostream &os, const vector<T> &v) {
        for (auto &e : v) os << e << (is_integral_v<T> && !is_same_v<T, char> ? " " : "");
        return os << '\n';
    }

    template<typename T>
    istream &operator>>(istream &is, vector<T> &v) {
        for (auto &e : v) is >> e;
        return is;
    }

    template<typename F, typename S>
    ostream &operator<<(ostream &os, const pair<F, S> &v) {
        os << v.first << " " << v.second << '\n';
        return os;
    }

    template<typename F, typename S>
    istream &operator>>(istream &is, const pair<F, S> &v) {
        is >> v.first >> v.second;
        return is;
    }
}

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) solve();
}

struct segment_tree {
    int n;
    vector<ll> max;

    explicit segment_tree(int n) : n(n), max(2 * n) {}

    void set(int i, ll x) {
        max[i += n] = x;
        for (i /= 2; i > 0; i /= 2) max[i] = ::max(max[2 * i], max[2 * i + 1]);
    }

    ll get(int l, int r) {
        ll ans = -1e18;
        if (l == -1) ans = 0, l++;
        for (l += n, r += n; l < r; l /= 2, r /= 2) {
            if (l & 1) ans = ::max(ans, max[l++]);
            if (r & 1) ans = ::max(ans, max[--r]);
        }
        return ans;
    }
};


void solve() {
    int n;
    cin >> n;
    vector<int> h(n), b(n);
    cin >> h >> b;
    segment_tree dp(n + 1);
    vector<int> stack{-1};
    vector<ll> best{(ll) -1e18};
    for (int i = 0; i < n; ++i) {
        while (!stack.empty() && stack.back() != -1 && h[i] < h[stack.back()]) {
            stack.pop_back();
            best.pop_back();
        }
        best.push_back(max(best.back(), dp.get(stack.back(), i) + b[i]));
        dp.set(i, best.back());
        stack.push_back(i);
    }
    cout << dp.get(n - 1, n) << '\n';
}