#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (B x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
    #define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
    #define dbg(...)
#endif

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

const ll INF = 1e18;

struct segtree {
    int n;
    vec<ll> tree;

    segtree(int n) : n(n), tree(2 * n, -INF) {}

    inline void update(int pos, ll val) {
        pos += n;
        tree[pos] = val;
        for (pos >>= 1; pos; pos >>= 1)
            tree[pos] = max(tree[pos << 1], tree[(pos << 1) | 1]);
    }

    inline ll get_max(int l, int r) {
        ll mx = -INF;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1)
                mx = max(mx, tree[l++]);
            if (r & 1)
                mx = max(mx, tree[--r]);
        }
        return mx;
    }
};

inline void solve() {
    int n;
    cin >> n;
    vec<int> h(n);
    for (auto &x : h)
        cin >> x;
    vec<int> b(n);
    for (auto &x : b)
        cin >> x;

    h.insert(h.begin(), -1);
    b.insert(b.begin(), 0);

    vec<ar<ll, 3>> st;
    st.push_back({-1, 0, 0});
    multiset<ll> valid;
    vec<ll> dp(n + 1);
    segtree tree(n + 1);
    tree.update(0, 0);

    for (int i = 1; i <= n; i++) {
        while (st.back()[0] > h[i]) {
            assert(len(st) > 1);
            valid.erase(valid.find(st.back()[1]));
            st.pop_back();
        }

        ll now = tree.get_max(st.back()[2], i) + b[i];
        st.push_back({h[i], now, i});
        valid.insert(now);
        // dbg(i, st, valid);

        dp[i] = *valid.rbegin();
        tree.update(i, dp[i]);
    }
    cout << dp.back() << '\n';
}

int main() {
    ios::sync_with_stdio(false), cin.tie(nullptr);

    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
