#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <stack>
#include <array>
#include <bitset>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <cmath>
#include <time.h>
#include <random>
#include <chrono>
#include <cassert>
#include <limits>

using namespace std;

#define int long long 
#define pb push_back
#define all(a) a.begin(), a.end()
#define pii pair<int, int>
#define ld long double

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 10;
#else 
	#define dbg(x) 
	const long long INF = 1e18;
	// const long long mod = 2600000069;
	// const long long p = 179;
#endif

// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC optimize("fast-math")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 3e5 + 10;

int n;
int h[N], b[N];
int mnl[N], mnr[N];

int t[4 * N];

void build(int v, int l, int r) {
	if (l + 1 == r) {
		t[v] = -INF;
		return;
	}
	int m = (l + r) / 2;
	build(2 * v + 1, l, m);
	build(2 * v + 2, m, r);
	t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

void setval(int v, int l, int r, int pos, int val) {
	if (l + 1 == r) {
		chkmax(t[v], val);
		return;
	}
	int m = (l + r) / 2;
	if (pos < m) setval(2 * v + 1, l, m, pos, val);
	else setval(2 * v + 2, m, r, pos, val);
	t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int ask(int v, int l, int r, int askl, int askr) {
	if (l >= askr || r <= askl) return -INF;
	if (l >= askl && r <= askr) return t[v];
	int m = (l + r) / 2;
	return max(ask(2 * v + 1, l, m, askl, askr), ask(2 * v + 2, m, r, askl, askr));
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
  	cin >> n;
  	for (int i = 0; i < n; i++) {
  		cin >> h[i];
  	}  
  	for (int i = 0; i < n; i++) {
  		cin >> b[i];
  	}
  	vector<int> s;
  	for (int i = 0; i < n; i++) {
  		mnr[i] = n;
  		mnl[i] = -1;
  	}
  	for (int i = 0; i < n; i++) {
  		while (!s.empty() && h[s.back()] > h[i]) {
  			mnr[s.back()] = i;
  			s.pop_back();
  		}
  		s.pb(i);
  	}
  	s.clear();
  	for (int i = n - 1; i >= 0; i--) {
  		while (!s.empty() && h[s.back()] > h[i]) {
  			mnl[s.back()] = i;
  			s.pop_back();
  		}
  		s.pb(i);
  	}
  	// for (int i = 0; i < n; i++) {
  	// 	cout << mnl[i] << " ";
  	// }
  	// cout << "\n";
  	// for (int i = 0; i < n; i++) {
  	// 	cout << mnr[i] << " ";
  	// }
  	// cout << "\n";
  	build(0, 0, n);
  	int mn = 0;
  	for (int i = 0; i < n; i++) {
  		if (h[i] < h[mn]) {
  			mn = i;
  		}
  		setval(0, 0, n, i, b[mn]);
  	}
  	set<pii, greater<pii>> have;
  	for (int i = 1; i < n; i++) {
  		int mx = ask(0, 0, n, mnl[i], i);
  		while (!have.empty() && (*have.begin()).second < i) {
  			have.erase(have.begin());
  		}
  		setval(0, 0, n, i, mx + b[i]);
  		have.insert({mx + b[i], mnr[i] - 1});
  		// dbg(i);
  		// cout << mx + b[i] << " " << mnr[i] - 1 << "\n";
  		if (!have.empty()) {
  			setval(0, 0, n, i, (*have.begin()).first);
  			// dbg((*have.begin()).first);
  		}
  	}
  	// for (int i = 0; i < n; i++) {
  	// 	cout << ask(0, 0, n, i, i + 1) << " ";
  	// }
  	// cout << "\n";
  	cout << ask(0, 0, n, n - 1, n) << "\n";
}
/*

*/