#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
int INF = 1e9;
int best(int a, int b) {
    return max(a, b);
}

struct SegmentTree {
    vector <int> tree;
    void build(int tl, int tr, int v, vector <int> &a) {
        if (tl == tr - 1) {
            tree[v] = a[tl];
        } else {
            int mid = (tl + tr) / 2;
            build(tl, mid, v * 2, a);
            build(mid, tr, v * 2 + 1, a);
            tree[v] = best(tree[v * 2], tree[v * 2 + 1]);
        }
    }

    SegmentTree (int n, vector <int> a) {
        tree.resize(n * 4, -INF);
        build(0, n, 1, a);
    }

    void update(int tl, int tr, int v, int el, int x) {
        if (tl > el || tr <= el) return;
        if (tl == tr - 1) {
            tree[v] = x;
        } else {
            int mid = (tl + tr) / 2;
            update(tl, mid, v * 2, el, x);
            update(mid, tr, v * 2 + 1, el, x);
            tree[v] = best(tree[v * 2], tree[v * 2 + 1]);
        }
    }

    int get_ans(int tl, int tr, int v, int l, int r) {
        if (tl >= r || tr <= l) return -INF;
        if (tl >= l && tr <= r) {
            return tree[v];
        } else {
            int mid = (tl + tr) / 2;
            return best(get_ans(tl, mid, v * 2, l, r), get_ans(mid, tr, v * 2 + 1, l, r));
        }
    }
};

void solve() {
    int n;
    cin >> n;
    vector <int> h(n), b(n);
    for (int i = 0; i < n; i++) cin >> h[i];
    for (int i = 0; i < n; i++) cin >> b[i];

    vector <pair <int, int> > st;
    vector <int> L(n + 1), R(n + 1);
    h.push_back(-INF);
    for (int i = 0; i <= n; i++) {
        if (st.empty() || h[i] > st.back().first) {
            L[i] = (st.size() ? st.back().second : -1);
            st.push_back({h[i], i});
        } else {
            while (!st.empty() && st.back().first > h[i]) {
                auto p = st.back();
                st.pop_back();
                R[p.second] = i;
            }
            L[i] = (st.size() ? st.back().second : -1);
            st.push_back({h[i], i});
        }
    }

    vector <int> dp(n), sum(n);
    sum[0] = b[0];
    for (int i = 1; i < n; i++) sum[i] = sum[i - 1] + b[i];
    vector <int> a(n);
    SegmentTree tree(n, a);
    dp[0] = b[0];
    tree.update(0, n, 1, 0, dp[0]);
    for (int i = 1; i < n; i++) {
        dp[i] = dp[i - 1] + b[i];
        if (L[i] != -1) dp[i] = max(dp[i], dp[L[i]]);
        int x = tree.get_ans(0, n, 1, L[i], i);
        if (L[i] == -1) x = max(x, 0ll);
        dp[i] = max(dp[i], x + b[i]);
        tree.update(0, n, 1, i, dp[i]);
    }
    cout << dp[n - 1] << endl;
}
signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie();
    cout.tie();
    int t = 1;
    while (t--) {
        solve();
    }
}

