#include <iostream>
#include <vector>
using namespace std;
using ll = long long;

const ll INF = 1e18;

struct segtree{
	void resize(int n){
		sz = 1;
		while(sz < n)
			sz *= 2;
		v.assign(sz * 2 - 1, -INF);
	}

	void insert(int i, ll vl){
		insert(0, 0, sz, i, vl);
	}

	ll getmax(int l, int r){
		return getmax(0, 0, sz, l, r);
	}

private:
	vector<ll> v;
	int sz;

	void insert(ll i_nd, ll l_nd, ll r_nd, ll i, ll vl){
		v[i_nd] = max(v[i_nd], vl);
		if(r_nd - l_nd == 1)
			return;
		ll m_nd = (l_nd + r_nd) / 2;
		if(i < m_nd)
			insert(i_nd * 2 + 1, l_nd, m_nd, i, vl);
		else
			insert(i_nd * 2 + 2, m_nd, r_nd, i, vl);
	}

	ll getmax(ll i_nd, ll l_nd, ll r_nd, ll l, ll r){
		if(l_nd >= l && r_nd <= r)
			return v[i_nd];
		else if(l_nd >= r || r_nd <= l)
			return -INF;
		else {
			int m_nd = (l_nd + r_nd) / 2;
			return max(getmax(i_nd * 2 + 1, l_nd, m_nd, l, r), getmax(i_nd * 2 + 2, m_nd, r_nd, l, r));
		}
	}
};

const ll MAXN = 3e5 + 123;
ll h[MAXN];
ll b[MAXN];
int pmin[MAXN];

void solve(){
	ll n;
	cin >> n;
	for(ll i = 1; i <= n; i++)
		cin >> h[i];
	for(ll i = 1; i <= n; i++)
		cin >> b[i];
	for(int i = 1; i <= n; i++){
		int j = i - 1;
		while(j > 0 && h[j] > h[i])
			j = pmin[j];
		pmin[i] = j;
	}
	vector<ll> dp(n + 1);
	segtree t;
	t.resize(n + 1);
	t.insert(0, 0);
	for(int i = 1; i <= n; i++){
		dp[i] = max(t.getmax(pmin[i], i) + b[i], (pmin[i] == 0 ? -INF : dp[pmin[i]]));
		t.insert(i, dp[i]);
	}
	cout << dp[n];
}

signed main(){
	solve();
	cout << '\n';
}
