#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <math.h>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <stack>

using namespace std;

typedef long long ll;

const ll N = 3e5 + 1;
const ll inf = 1e18;
const ll sz = (1 << 19);

pair <ll, ll> D[2 * sz];
ll p[2 * sz];

void push(ll v) {
	if (D[v].second == -inf) {
		return;
	}
	if (v >= sz) {
		D[v].first = p[v] + D[v].second;
		D[v].second = -inf;
		return;
	}
	D[v].first = max(p[2 * v], p[2 * v + 1]) + D[v].second;
	p[v] = max(p[2 * v], p[2 * v + 1]);
	D[2 * v].second = D[v].second;
	D[2 * v + 1].second = D[v].second;
	D[v].second = -inf;
}

void upd(ll l1, ll r1, ll l, ll r, ll v, ll val) {
	if (l1 > r || r1 < l) {
		return;
	}
	if (l1 <= l && r1 >= r) {
		D[v].second = val;
		push(v);
		return;
	}
	push(v);
	ll mid = (r + l) / 2;
	upd(l1, r1, l, mid, 2 * v, val);
	upd(l1, r1, mid + 1, r, 2 * v + 1, val);
	D[v].first = max(D[2 * v + 1].first, D[2 * v].first);
	p[v] = max(p[2 * v + 1], p[2 * v]);
	return;
}

ll get(ll l1, ll r1, ll l, ll r, ll v) {
	if (l1 > r || r1 < l) {
		return -inf;
	}
	push(v);
	if (l1 <= l && r1 >= r) {
		return D[v].first;
	}
	ll mid = (r + l) / 2;
	ll k1 = get(l1, r1, l, mid, 2 * v);
	ll k2 = get(l1, r1, mid + 1, r, 2 * v + 1);
	return max(k1, k2);
}

void upd1(ll val, ll v, ll cur, ll l, ll r) {
	push(v);
	if (cur == v) {
		p[v] = val;
		D[v].first = val;
		return;
	}
	ll mid = (r + l) / 2;
	if (v <= mid) {
		upd1(val, v, cur * 2, l, mid);
	}
	else {
		upd1(val, v, cur * 2 + 1, mid + 1, r);
	}
	D[cur].first = max(D[2 * cur + 1].first, D[2 * cur].first);
	p[cur] = max(p[2 * cur + 1], p[2 * cur]);
}

ll h[N], b[N], dp[N], pre[N];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ll t = 1;
	//cin >> t;
	while (t--) {
		ll n;
		cin >> n;
		for (ll i = 1; i <= n; i++) {
			cin >> h[i];
		}
		for (ll i = 1; i <= n; i++) {
			cin >> b[i];
		}
		for (ll i = 1; i < 2 * sz; i++) {
			D[i].second = -inf;
		}
		for (ll i = 1; i <= n; i++) {
			ll cur = i - 1;
			while (h[cur] > h[i]) {
				cur = pre[cur];
			}
			pre[i] = cur;
		}
		for (ll i = 1; i <= n; i++) {
			upd(pre[i] + sz, i - 1 + sz, sz, 2 * sz - 1, 1, b[i]);
			dp[i] = get(sz, i - 1 + sz, sz, 2 * sz - 1, 1);
			upd1(dp[i], i + sz, 1, sz, 2 * sz - 1);
		}
		cout << dp[n];
	}
}