#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 300005;
const int MAX_K = 21;
int n;
int h[MAX_N];
ll b[MAX_N];
ll dp[MAX_N];
int minh[MAX_N][MAX_K];
ll maxdp[MAX_N][MAX_K];

ll get_maxdp(int l, int r)
{
    if (l < 0)
        l = 0;

    int j = 1;
    while ((1 << j) <= (r - l + 1))
        j++;
    j--;

    return max(maxdp[r][j], maxdp[l + (1 << j) - 1][j]);
}

int main()
{
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n;
    for (int i = 0; i < n; i++)
    {
        cin >> h[i];
    }
    for (int i = 0; i < n; i++)
    {
        cin >> b[i];
    }

    dp[0] = b[0];
    minh[0][0] = h[0];
    maxdp[0][0] = dp[0];
    for (int i = 1; i < n; i++)
    {
        if (h[i - 1] < h[i])
        {
            dp[i] = max(dp[i - 1], dp[i - 1] + b[i]);
        }
        else
        {
            int cur = i - 1;
            for (int k = MAX_K - 1; k >= 0 && cur >= 0; k--)
            {
                if (cur - (1 << k) + 1 >= 0 && minh[cur][k] > h[i])
                {
                    cur -= (1 << k);
                }
            }
            //cout << cur << " ";
            dp[i] = get_maxdp(cur, i - 1) + b[i];
            if (cur < 0)
                dp[i] = max(dp[i], b[i]);
            if (cur >= 0)
                dp[i] = max(dp[i], dp[cur]);
        }

        minh[i][0] = h[i];
        for (int k = 1; k < MAX_K; k++)
        {
            if (i - (1 << k) + 1 < 0)
                break;
            minh[i][k] = min(minh[i][k - 1], minh[i - (1 << (k - 1))][k - 1]);
        }

        maxdp[i][0] = dp[i];
        for (int k = 1; k < MAX_K; k++)
        {
            if (i - (1 << k) + 1 < 0)
                break;
            maxdp[i][k] = max(maxdp[i][k - 1], maxdp[i - (1 << (k - 1))][k - 1]);
        }
    }
    //cout << endl;

    cout << dp[n - 1];

    return 0;
}