#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

#define int long long

const int INF = 1e18 + 239;
const int N = 3e5 + 7;

int n;
int h[N];
int b[N];

int l[N];
int r[N];
int dp[N];
vector<int> toer[N];

namespace SegmentTree {
    int t[4 * N];

    void pull(int v) {
        t[v] = max(t[2 * v + 1], t[2 * v + 2]);
    }

    void init() {
        fill(t, t + 4 * N, -INF);
    }

    void set(int v, int l, int r, int pos, int val) {
        if (l + 1 == r) {
            t[v] = val;
        } else {
            int m = (r + l) / 2;
            if (pos < m) {
                set(2 * v + 1, l, m, pos, val);
            } else {
                set(2 * v + 2, m, r, pos, val);
            }
            pull(v);
        }
    }

    void set(int pos, int val) {
        set(0, 0, N, pos, val);
    }

    void query(int v, int l, int r, int ql, int qr, int &ans) {
        if (qr <= l || r <= ql) {
            //
        } else if (ql <= l && r <= qr) {
            ans = max(ans, t[v]);
        } else {
            int m = (r + l) / 2;
            query(2 * v + 1, l, m, ql, qr, ans);
            query(2 * v + 2, m, r, ql, qr, ans);
        }
    }

    int mx(int l, int r) {
        int ans = -INF;
        query(0, 0, N, l, r, ans);
        return ans;
    }
}

void init() {
    {
        vector<int> st;
        for (int i = 0; i < n; i++) {
            while (!st.empty() && h[st.back()] >= h[i]) {
                st.pop_back();
            }
            if (st.empty()) {
                l[i] = -1;
            } else {
                l[i] = st.back();
            }
            st.push_back(i);
        }
    }
    {
        vector<int> st;
        for (int i = n - 1; i >= 0; i--) {
            while (!st.empty() && h[st.back()] >= h[i]) {
                st.pop_back();
            }
            if (st.empty()) {
                r[i] = n;
            } else {
                r[i] = st.back();
            }
            st.push_back(i);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    SegmentTree::init();

    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    init();
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }
    multiset<int> val;
    for (int i = 0; i < n; i++) {
        for (auto v : toer[i]) {
            val.erase(val.find(v));
        }
        dp[i] = -INF;
        if (l[i] == -1) {
            dp[i] = max(dp[i], (int)0);
        }
        if (!val.empty()) {
            dp[i] = max(dp[i], *val.rbegin());
        }
        dp[i] = max(dp[i], SegmentTree::mx(l[i] + 1, i));
        dp[i] += b[i];
        val.insert(dp[i]);
        toer[r[i]].push_back(dp[i]);
        SegmentTree::set(i, dp[i]);
    }
    int ans = -INF;
    for (int i = 0; i < n; i++) {
        if (r[i] == n) {
            ans = max(ans, dp[i]);
        }
    }
    cout << ans << '\n';
}
