#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MAXN = 3e5 + 10;
const int INF = 1e17;

pair<int, int> tree1[MAXN * 4];
pair<int, int> tree2[MAXN * 4];
int mod[MAXN * 4];

int n;

void build1() {
  fill(tree1, tree1 + 4 * n + 10, make_pair(-INF, -1));
}

void upd1(int v, int l, int r, int qi, int qx) {
  if (qi < l || r <= qi)
    return;
  if (l + 1 == r) {
    tree1[v] = {qx, l};
    return;
  }
  int m = (l + r) / 2;
  upd1(2 * v + 1, l, m, qi, qx);
  upd1(2 * v + 2, m, r, qi, qx);
  tree1[v] = max(tree1[2 * v + 1], tree1[2 * v + 2]);;
}

void build2() {
  fill(tree2, tree2 + 4 * n + 10, make_pair(-INF, -1));
  fill(mod, mod + 4 * n + 10, -INF);
}

void push(int v) {
  if (mod[v] == -INF)
    return;
  tree2[v] = tree1[v];
  tree2[v].first += mod[v];
  mod[2 * v + 1] = mod[v];
  mod[2 * v + 2] = mod[v];
  mod[v] = -INF;
}

void upd2(int v, int l, int r, int ql, int qr, int qx) {
  if (qr <= l || r <= ql)
    return;
  push(v);
  if (ql <= l && r <= qr) {
    mod[v] = qx;
    push(v);
    return;
  }
  int m = (l + r) / 2;
  upd2(2 * v + 1, l, m, ql, qr, qx);
  upd2(2 * v + 2, m, r, ql, qr, qx);
  tree2[v] = max(tree2[2 * v + 1], tree2[2 * v + 2]);;
}

void upd2(int v, int l, int r, int qi) {
  if (qi < l || r <= qi)
    return;
  push(v);
  if (l + 1 == r) {
    return;
  }
  int m = (l + r) / 2;
  upd2(2 * v + 1, l, m, qi);
  upd2(2 * v + 2, m, r, qi);
  tree2[v] = max(tree2[2 * v + 1], tree2[2 * v + 2]);;
}

pair<int, int> get(int v, int l, int r, int ql, int qr) {
  if (qr <= l || r <= ql)
    return {-INF, -1};
  if (ql <= l && r <= qr)
    return tree2[v];
  int m = (l + r) / 2;
  auto a = get(2 * v + 1, l, m, ql, qr);
  auto b = get(2 * v + 2, m, r, ql, qr);
  return max(a, b);
}

vector<int> lll, hh;

void calclll() {
  vector<int> st;
  lll.resize(n, -1);
  for (int i = 0; i < n; ++i) {
    while (!st.empty() && hh[st.back()] > hh[i]) {
      st.pop_back();
    }
    if (!st.empty())
      lll[i] = st.back();
    st.push_back(i);
  }
}

void solve() {
  cin >> n;
  vector<int> bb(n);
  hh.resize(n);
  for (int &el : hh)
    cin >> el;
  for (int &el : bb)
    cin >> el;
  build1();
  build2();
  calclll();
  vector<int> dp(n + 1, 0);
  upd1(0, 0, n + 1, 0, 0);
  upd2(0, 0, n + 1, 0);
//  upd2(0, 0, n + 1, 0, 1, 0);
  for (int i = 1; i <= n; ++i) {
    int ll = lll[i - 1] + 1;
    upd2(0, 0, n + 1, ll, i, bb[i - 1]);
    auto[val, j] = get(0, 0, n + 1, 0, i);
    dp[i] = val;
    upd1(0, 0, n + 1, i, val);
    upd2(0, 0, n + 1, i);
  }
  cout << dp[n];
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int t = 1;
//  cin >> t;
  while (t--) {
    solve();
    cout << '\n';
  }
}