#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;

int n, * h, * b, * max_log, ** min_ind;

struct ans
{
	ll pref, suff, seg, val;
	ans(ll pref = 0, ll suff = 0, ll seg = 0, ll val = 0): pref(pref), suff(suff), seg(seg), val(val) {}
};

inline void build_sparse_table()
{
	max_log = new int[n + 1];
	max_log[0] = 0;
	for (int i = 1; i <= n; i++)
	{
		max_log[i] = max_log[i - 1];
		if ((1 << (max_log[i] + 1)) <= i)
			max_log[i]++;
	}
	min_ind = new int* [max_log[n] + 1];
	for (int lg = 0; lg <= max_log[n]; lg++)
	{
		min_ind[lg] = new int[n];
		for (int i = 0; i < n; i++)
		{
			if (lg == 0)
			{
				min_ind[lg][i] = i;
				continue;
			}
			int j = min(i + (1 << (lg - 1)), n - 1);
			int ind1 = min_ind[lg - 1][i], ind2 = min_ind[lg - 1][j];
			if (h[ind1] < h[ind2])
				min_ind[lg][i] = ind1;
			else
				min_ind[lg][i] = ind2;
		}
	}
}

inline int get_min_ind(int l, int r)
{
	int lg = max_log[r - l];
	int m = r - (1 << lg);
	int ind1 = min_ind[lg][l], ind2 = min_ind[lg][m];
	if (h[ind1] <= h[ind2])
		return ind1;
	else
		return ind2;
}

inline ans get_max_ans(int l, int r)
{
	if (l >= r)
		return ans();
	int m = get_min_ind(l, r);
	ans ans_l = get_max_ans(l, m), ans_r = get_max_ans(m + 1, r);
	ans now;
	now.pref = max({ 0ll, ans_l.pref, ans_l.pref + b[m] + ans_r.seg });
	now.suff = max({ 0ll, ans_r.suff, ans_r.suff + b[m] + ans_l.seg });
	now.seg = max({ ans_l.seg, ans_r.seg, ans_l.seg + b[m] + ans_r.seg });
	now.val = ans_l.pref + b[m] + ans_r.suff;
	return now;
}

int main()
{
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);
	cin >> n;
	h = new int[n], b = new int[n];
	for (int i = 0; i < n; i++)
		cin >> h[i];
	for (int i = 0; i < n; i++)
		cin >> b[i];
	build_sparse_table();
	cout << get_max_ans(0, n).val << "\n";
}
