//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>

#define all(v) v.begin(), v.end()
#define int long long

using namespace std;


const int maxn = 3e5 + 10;

const int inf = 1e9 * maxn + 7;

int t[maxn * 4];
int add[maxn * 4];

void push(int v, int tl, int tr) {
    t[v] = max(t[v], add[v]);
    if (tr - tl > 1) {
        add[v * 2] = max(add[v * 2], add[v]);
        add[v * 2 + 1] = max(add[v * 2 + 1], add[v]);
    }
    add[v] = -inf;
}

void update(int l, int r, int c, int v = 1, int tl = 0, int tr = maxn) {
    if (tl < tr) push(v, tl, tr);
    if (tr <= l || r <= tl) return;
    if (l <= tl && tr <= r) {
        add[v] = max(add[v], c);
        push(v, tl, tr);
        return;
    }
    int m = (tl + tr) / 2;
    update(l, r, c, v * 2, tl, m);
    update(l, r, c, v * 2 + 1, m, tr);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
}

int get(int l, int r, int v = 1, int tl = 0, int tr = maxn) {
    if (tl < tr) push(v, tl, tr);
    if (tr <= l || r <= tl) return -inf;
    if (l <= tl && tr <= r) return t[v];
    int m = (tl + tr) / 2;
    return max(get(l, r, v * 2, tl, m), get(l, r, v * 2 + 1, m, tr));
}


void build(int v = 1, int tl = 0, int tr = maxn) {
    if (tr - tl == 1) {
        t[v] = -inf;
        add[v] = -inf;
        return;
    }
    int m = (tl + tr) / 2;
    build(v * 2, tl, m);
    build(v * 2 + 1, m, tr);
    t[v] = max(t[v * 2], t[v * 2 + 1]);
    add[v] = -inf;
}

int h[maxn];
int b[maxn];

int ln[maxn];
int rn[maxn];

signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    for (int i = 0; i < n; ++i) {
        cin >> b[i];
    }
    vector<int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && h[st.back()] >= h[i]) st.pop_back();
        if (st.empty())
            ln[i] = -1;
        else
            ln[i] = st.back();
        st.push_back(i);
    }
    st.clear();
    for (int i = n - 1; i >= 0; --i) {
        while (!st.empty() && h[st.back()] >= h[i]) st.pop_back();
        if (st.empty())
            rn[i] = n;
        else
            rn[i] = st.back();
        st.push_back(i);
    }
    build();
    update(0, 1, 0);
    for (int i = 0; i < n; ++i) {
        int best = get(ln[i] + 1, i + 1) + b[i];
        update(i + 1, rn[i] + 1, best);
//        cout << "dp\n";
//        for (int j = 0; j < n; ++j) {
//            cout << get(j, j + 1) << " ";
//        }
//        cout << "\n";
    }
    cout << get(n, n + 1);
    return 0;
}
