#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <stack>
#include <map>

#define F first
#define S second
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define siz(a) int(a.size())

using namespace std;
using ll = long long;
using ld = long double;
using vi = vector<int>;
using pi = pair<int, int>;
using vll = vector<ll>;

template<class T> bool ckmin(T &a, T b) {return a > b ? a = b, true : false;}
template<class T> bool ckmax(T &a, T b) {return a < b ? a = b, true : false;}

const int N = 2e5 + 7;
const int INF = 1e9;
const ll LINF = 1e18;

struct sgt{
    vll t;
    int sz = 1;

    sgt(int n) {
        while(sz < n) sz <<= 1;
        t.resize(2*sz, -INF);
    }

    void upd(int i, ll x) {
        i += sz;
        t[i] = x;
        for (i = i/2; i > 0; i/=2) {
            t[i] = max(t[i*2], t[i*2+1]);
        }
    }

    ll get(int i) {
        i += sz;
        return t[i];
    }

    ll rmq(int i, int j) {
        if(i > j) return -INF;
        ll ans = -INF;
        for (i+=sz, j+=sz; i <= j; i/=2, j/=2) {
            if((i%2)) ckmax(ans, t[i]), i++;
            if(!(j%2)) ckmax(ans, t[j]), j--;
        }
        return ans;
    }
};


struct line{
    int l, r;
    ll val;
};


void solve() {
    int n; cin >> n;
    vi h(n), b(n);
    vll dp(n, -LINF);
    for (auto &x:h) cin >> x;
    for (auto &x:b) cin >> x;
    stack<pi> left_min; left_min.push({h[0], 0});
    sgt tree(n); dp[0] = b[0];
    tree.upd(0, dp[0]);
    vector<line> seg; seg.pb({0, 0, dp[0]});
    set<pair<ll, int>> st;
    st.insert({dp[0], siz(seg)-1});
    for (int i = 1; i < n; ++i) {
        int prv = -1;
        while(siz(left_min) && left_min.top().F > h[i]) left_min.pop();
        if(siz(left_min)) prv = left_min.top().S; left_min.push({h[i], i});
        int l = prv + 1, r = i;
        while(siz(seg) && seg.back().l >= l) {
            st.erase({seg.back().val, siz(seg)-1});
            seg.pop_back();
        }
        if(st.size())dp[i] = st.rbegin() -> F + max(b[i], 0);
        else ckmax(dp[i], (ll)b[i]);
        if(l <= r-1) ckmax(dp[i], tree.rmq(l, r-1) + b[i]);
        tree.upd(i, dp[i]);
        seg.pb({l, r, dp[i]});
        st.insert({dp[i], siz(seg)-1});


    }
    cout << dp[n-1] << "\n";
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    while(t--) solve();
    return 0;
}
