#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const ll inf = 1e15;

struct segment_tree {
  int size;
  vector<ll> add, tr;
  segment_tree() {}
  segment_tree(int sz) {
    size = sz;
    add.resize(4 * size);
    tr.resize(4 * size);
  }
  void push(int t, int l, int r) {
    if (add[t] == 0)
      return;
    tr[t] += add[t];
    if (l + 1 != r) {
      add[t * 2 + 1] += add[t];
      add[t * 2 + 2] += add[t];
    }
    add[t] = 0;
  }

  void addr(int t, int l, int r, int x, int y, ll val) {
    push(t, l, r);
    if (l >= x && r <= y) {
      add[t] += val;
      push(t, l, r);
      return;
    }
    if (l >= y || r <= x)
      return;
    int md = r + l >> 1;
    addr(t * 2 + 1, l, md, x, y, val);
    addr(t * 2 + 2, md, r, x, y, val);
    tr[t] = max(tr[t * 2 + 1], tr[t * 2 + 2]);
  }
  void addr(int l, int r, ll val) {
    addr(0, 0, size, max(0, l), min(size, r + 1), val);
  }

  ll get_mx(int t, int l, int r, int x, int y) {
    push(t, l, r);
    if (l >= x && r <= y)
      return tr[t];
    if (l >= y || r <= x)
      return -inf;
    int md = r + l >> 1;
    return max(get_mx(t * 2 + 1, l, md, x, y), get_mx(t * 2 + 2, md, r, x, y));
  }
  ll get_mx(int l, int r) {
    return get_mx(0, 0, size, max(0, l), min(size, r + 1));
  }
};


struct segment {
  int l, r;
  ll h, b;
};
void solve() {
  int n;
  cin >> n;
  vector<ll> h(n), b(n);
  vector<ll> prb(n);
  ll mnh = inf, curb = 0;
  for (int i = 0; i < n; ++i)
    cin >> h[i];
  for (int i = 0; i < n; ++i)
    cin >> b[i];
  for (int i = 0; i < n; ++i) {
    if (h[i] < mnh) {
      mnh = h[i];
      curb = b[i];
    }
    prb[i] = curb;
  }

  segment_tree sgt(n);
  vector<segment> stk;
  for (int i = 0; i < n; ++i) {
    segment cur = {i, i, h[i], b[i]};
    sgt.addr(i - 1, i - 1, b[i]);
    while (!stk.empty() && h[i] < stk.back().h) {
      auto last = stk.back();
      stk.pop_back();
      sgt.addr(last.l - 1, last.r - 1, cur.b - last.b);
      cur.l = last.l;
    }
    stk.push_back(cur);
    ll val = max(prb[i], sgt.get_mx(0, i - 1));
    sgt.addr(i, i, val);
  }
  cout << sgt.get_mx(n - 1, n - 1) << '\n';
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
}