#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
 
const ll INF = 1e18;
 
struct SegTree {    
    int n;
    vector<ll> t;
    
    void build(const vector<ll> &a) {
        n = 1;
        while (n < (int)a.size()) n *= 2;
        t = vector<ll>(2 * n, -INF);
        for (int i = 0; i < (int)a.size(); ++i) t[i + n] = a[i];
        for (int i = n - 1; i > 0; --i) t[i] = max(t[2 * i], t[2 * i + 1]);
    }
    
    ll query(int l, int r) {
        l += n, r += n;
        ll res = -INF;
        while (l < r) {
            if (l & 1) {
                res = max(res, t[l]);
                ++l;
            }
            if (r & 1) {
                --r;
                res = max(res, t[r]);
            }
            l >>= 1, r >>= 1;
        }
        return res;
    }
    
    void modify(int pos, ll val) {
        int i = pos + n;
        t[i] = val;
        for (; i > 1; i >>= 1) t[i >> 1] = max(t[i], t[i ^ 1]);
    }
    
    SegTree(const vector<ll> &a) {
        build(a);
    }
};
 
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; ++i) cin >> h[i];
    vector<ll> b(n);
    for (int i = 0; i < n; ++i) cin >> b[i];
    vector<ll> dp(n + 1, -INF);
    dp[0] = 0;
    SegTree tree(dp);
    vector<int> st = {-1};
    multiset<ll> have;
    for (int i = 0; i < n; ++i) {
        while ((int)st.size() >= 2 && h[st.back()] > h[i]) {
            int sz = (int)st.size();
            have.erase(have.find(tree.query(st[sz - 2] + 1, st.back() + 1) + b[st.back()]));
            st.pop_back();
        }
        have.insert(tree.query(st.back() + 1, i + 1) + b[i]);
        st.push_back(i);
        dp[i + 1] = *have.rbegin();
        tree.modify(i + 1, dp[i + 1]);
    }
    cout << dp[n] << endl;
    return 0;
}
