#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <string>
#include <ctime>
#include <queue>
#include <numeric>
#include <random>
#include <immintrin.h>
/*
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.2,avx,popcnt,abm,mmx,tune=native")
#pragma GCC target("avx2")
#pragma GCC optimize("Ofast,fast-math,no-stack-protector,unroll-loops,inline")
*/
/*
#pragma GCC optimize(3)
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("profile-values,profile-reorder-functions,tracer")
#pragma GCC optimize("vpt")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("move-loop-invariants")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("function-sections")
#pragma GCC optimize("data-sections")
#pragma GCC optimize("branch-target-load-optimize")
#pragma GCC optimize("branch-target-load-optimize2")
#pragma GCC optimize("btr-bb-exclusive")
#pragma GCC optimize("inline")
#pragma GCC optimize("-fgcse")
#pragma GCC optimize("-fgcse-lm")
#pragma GCC optimize("-fipa-sra")
#pragma GCC optimize("-ftree-pre")
#pragma GCC optimize("-ftree-vrp")
#pragma GCC optimize("-fpeephole2")
#pragma GCC optimize("-ffast-math")
#pragma GCC optimize("-fsched-spec")
#pragma GCC optimize("-falign-jumps")
#pragma GCC optimize("-falign-loops")
#pragma GCC optimize("-falign-labels")
#pragma GCC optimize("-fdevirtualize")
#pragma GCC optimize("-fcaller-saves")
#pragma GCC optimize("-fcrossjumping")
#pragma GCC optimize("-fthread-jumps")
#pragma GCC optimize("-freorder-blocks")
#pragma GCC optimize("-fschedule-insns")
#pragma GCC optimize("inline-functions")
#pragma GCC optimize("-ftree-tail-merge")
#pragma GCC optimize("-fschedule-insns2")
#pragma GCC optimize("-fstrict-aliasing")
#pragma GCC optimize("-falign-functions")
#pragma GCC optimize("-fcse-follow-jumps")
#pragma GCC optimize("-fsched-interblock")
#pragma GCC optimize("-fpartial-inlining")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("-freorder-functions")
#pragma GCC optimize("-findirect-inlining")
#pragma GCC optimize("-fhoist-adjacent-loads")
#pragma GCC optimize("-frerun-cse-after-loop")
#pragma GCC optimize("inline-small-functions")
#pragma GCC optimize("-finline-small-functions")
#pragma GCC optimize("-ftree-switch-conversion")
#pragma GCC optimize("-foptimize-sibling-calls")
#pragma GCC optimize("-fexpensive-optimizations")
#pragma GCC optimize("inline-functions-called-once")
#pragma GCC optimize("-fdelete-null-pointer-checks")
*/
// #define int long long
using namespace std;
typedef long double ld;
typedef long long ll;
const int inf = 1e9 + 7;
const ll l_inf = (ll) inf * (ll) inf;
const ld eps = 1e-6;
const int MAXN = 603;
vector<pair<int, ll>> G[MAXN];
vector<pair<int, ll>> Q[MAXN];
int n, m;
bool used[MAXN][MAXN];


vector<ll> Dijkstra(int s) {
    vector<ll> D(n, l_inf);
    D[s] = 0;
    vector<bool> C(n, false);
    C[s] = true;
    while (true) {
        int v = -1;
        for (int u = 0; u < n; ++u) {
            if (C[u] && (v == -1 || D[u] < D[v])) {
                v = u;
            }
        }
        if (v == -1) {
            break;
        }
        C[v] = false;
        for (auto [u, w] : G[v]) {
            if (D[u] > D[v] + w) {
                D[u] = D[v] + w;
                C[u] = true;
            }
        }
    }
    return D;
}


signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        ll a, b, w;
        cin >> a >> b >> w;
        --a;
        --b;
        G[a].emplace_back(b, w);
        G[b].emplace_back(a, w);
    }
    //
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int a, b, l;
        cin >> a >> b >> l;
        --a;
        --b;
        Q[a].emplace_back(b, l);
    }
    //
    ll res = 0;
    for (int s = 0; s < n; ++s) {
        vector<ll> D1 = Dijkstra(s);
        //
        vector<ll> D2(n, l_inf);
        vector<bool> C(n, false);
        for (auto [t, l] : Q[s]) {
            D2[t] = -l;
            C[t] = true;
        }
        while (true) {
            int v = -1;
            for (int u = 0; u < n; ++u) {
                if (C[u] && (v == -1 || D2[u] < D2[v])) {
                    v = u;
                }
            }
            if (v == -1) {
                break;
            }
            C[v] = false;
            for (auto [u, w] : G[v]) {
                if (D2[u] > D2[v] + w) {
                    D2[u] = D2[v] + w;
                    C[u] = true;
                }
            }
        }
        //
        for (int v = 0; v < n; ++v) {
            for (auto [u, w] : G[v]) {
                ll d = min(D1[v] + w + D2[u], D1[u] + w + D2[v]);
                if (d <= 0) {
                    if (!used[v][u]) {
                        ++res;
                        used[v][u] = true;
                        used[u][v] = true;
                    }
                }
            }
        }
    }
    //
    cout << res << "\n";
    cerr << 1.0 * clock() / CLOCKS_PER_SEC << "\n";
    return 0;
}
