#include<bits/stdc++.h>

using namespace std;

//#define int long long

using ll = long long;

namespace {
    template<typename T>
    ostream &operator<<(ostream &os, const vector<T> &v) {
        for (auto &e : v) os << e << (is_integral_v<T> && !is_same_v<T, char> ? " " : "");
        return os << '\n';
    }

    template<typename T>
    istream &operator>>(istream &is, vector<T> &v) {
        for (auto &e : v) is >> e;
        return is;
    }

    template<typename F, typename S>
    ostream &operator<<(ostream &os, const pair<F, S> &v) {
        os << v.first << " " << v.second << '\n';
        return os;
    }

    template<typename F, typename S>
    istream &operator>>(istream &is, const pair<F, S> &v) {
        is >> v.first >> v.second;
        return is;
    }
}

void solve();

signed main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) solve();
}

struct edge {
    int u, v, w;
    bool useful = false;

    friend istream &operator>>(istream &is, edge &e) {
        is >> e.u >> e.v >> e.w;
        --e.u, --e.v;
        return is;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    vector<edge> edges(m);
    vector<vector<ll>> dist(n, vector<ll>(n, 1e18));
    for (int i = 0; i < n; ++i) dist[i][i] = 0;
    vector<vector<int>> graph(n);
    for (int j = 0; j < m; ++j) {
        cin >> edges[j];
        auto[u, v, w, useful] = edges[j];
        graph[u].push_back(j);
        graph[v].push_back(j);
        dist[u][v] = min(dist[u][v], (ll) w);
        dist[v][u] = min(dist[v][u], (ll) w);
    }
    vector<vector<ll>> len(n, vector<ll>(n, -1e18));
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int u, v, l;
        cin >> u >> v >> l;
        --u, --v;
        len[u][v] = l;
    }

    for (int t = 0; t < n; ++t) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                dist[i][j] = min(dist[i][j], dist[i][t] + dist[t][j]);
            }
        }
    }
    auto get = [&](int v, int i) -> edge & { return edges[graph[v][i]]; };
    auto next = [&](int v, int i) { return get(v, i).u ^ get(v, i).v ^ v; };
    for (int i = 0; i < n; ++i) {
        vector<ll> mx(n, -1e18);
        for (int j = 0; j < n; ++j) {
            for (int k = 0; k < n; ++k) {
                mx[k] = max(mx[k], len[i][j] - dist[j][k]);
            }
        }

        for (auto &e : edges) {
            if (dist[i][e.u] + e.w <= mx[e.v]) {
                e.useful = true;
            }
            if (dist[i][e.v] + e.w <= mx[e.u]) {
                e.useful = true;
            }
        }
    }
    cout << count_if(edges.begin(), edges.end(), [](edge e) { return e.useful; }) << '\n';
}
