#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <algorithm>
#include <string>
#include <cmath>
#include <cstdio>
#include <iomanip>
#include <fstream>
#include <cassert>
#include <cstring>
#include <unordered_set>
#include <unordered_map>
#include <numeric>
#include <ctime>
#include <bitset>
#include <complex>
#include <chrono>
#include <random>
#include <functional>

using namespace std;

#define int long long

struct Edge {
    int f, s, w;
    int ok;

    Edge() {
        f = 0;
        s = 0;
        w = 0;
        ok = 0;
    }

    Edge(int f_, int s_, int w_) {
        f = f_;
        s = s_;
        w = w_;
        ok = 0;
    }
};

const int N = 601;
const int INF = 1e18 + 239;

int n;
vector<Edge> e;

vector<pair<int, int>> bu[N]; //{v, l}

int d[N][N];

int val[N];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);


    int m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            d[i][j] = INF;
        }
        d[i][i] = 0;
    }
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        d[u][v] = min(d[u][v], w);
        d[v][u] = min(d[v][u], w);
        e.push_back(Edge(u, v, w));
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int u, v, l;
        cin >> u >> v >> l;
        u--;
        v--;
        bu[u].push_back({v, l});
        bu[v].push_back({u, l});
    }
    //
    for (int u = 0; u < n; u++) {
        fill(val, val + N, -INF);
        for (auto [v, l] : bu[u]) {
            for (int s = 0; s < n; s++) {
                val[s] = max(val[s], l - d[v][s]);
            }
        }
        for (auto &ce : e) {
            ce.ok |= (d[u][ce.f] + ce.w <= val[ce.s]);
        }
    }
    //
    int ans = 0;
    for (auto ce : e) {
        ans += ce.ok;
    }
    cout << ans << '\n';
}
