//#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int ll

vector<vector<pair<int, int>>> g;
vector<vector<int>> kek;
vector<vector<pair<int, int>>> good;

int n;
const int INF = 1e14;

int add(int a, int b) {
    int c = a + b;
    if (c >= INF)
        return INF;
    return  c;
}

vector<vector<int>> floyd;


void run1(int u) {
    vector<int> dist = floyd[u];
    vector<int> dist2(n, INF);
    for (auto pp : good[u]) {
        int v = pp.first;
        dist2[v] = min(dist2[v], -pp.second);
        for (int i = 0; i < n; i++) {
            if (floyd[v][i] != INF)
                dist2[i] = min(dist2[i], floyd[v][i] - pp.second);
        }
    }
    for (int u = 0; u < n; u++) {
        for (int i = 0; i < (int) g[u].size(); i++) {
            int v = g[u][i].first;
            int c = g[u][i].second;
            if (dist[v] != INF && dist[u] != INF && dist[u] + c + dist2[v] <= 0) {
                kek[u][i] = 1;
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int m;
    cin >> n >> m;
    g.resize(n);
    good.resize(n);
    kek.resize(n);
    vector<vector<int>> edges;
    floyd.resize(n, vector<int> (n, INF));
    for (int i = 0; i < n; i++) {
        floyd[i][i] = 0;
    }
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        edges.push_back({a, b, (int) g[a].size(), (int) g[b].size()});
        g[a].push_back({b, c});
        g[b].push_back({a, c});
        kek[a].push_back(0);
        kek[b].push_back(0);
        floyd[a][b] = floyd[b][a] = c;
    }

    
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                floyd[i][j] = min(floyd[i][j], add(floyd[i][k], floyd[k][j]));
            }
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        good[a].push_back({b, c});
        good[b].push_back({a, c});
    }
    for (int i = 0; i < n; i++) {
        if (!good[i].empty())
            run1(i);
    }
    int ans = 0;
    for (auto &el : edges) {
        int ans2 = ans;
        ans += max(kek[el[0]][el[2]], kek[el[1]][el[3]]);
    }
    cout << ans << endl;
}
