#include <bits/stdc++.h>

using namespace std;

#define int long long


const int INF = 1000000000000000LL;


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;

	vector< vector<int> > dist(n, vector<int>(n, INF));
	vector< tuple<int, int, int, int> > edges;
	for(int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--; v--;
		dist[u][v] = min(dist[u][v], w);
		dist[v][u] = min(dist[v][u], w);
		edges.emplace_back(u, v, w, i);
		edges.emplace_back(v, u, w, i);
	}

	for(int u = 0; u < n; u++) {
		dist[u][u] = 0;
	}

	for(int k = 0; k < n; k++) {
		for(int u = 0; u < n; u++) {
			for(int v = 0; v < n; v++) {
				dist[u][v] = min(dist[u][v], dist[u][k] + dist[k][v]);
			}
		}
	}

	int q;
	cin >> q;

	vector< vector< pair<int, int> > > queries_by_u(n);
	for(int i = 0; i < q; i++) {
		int u, v, l;
		cin >> u >> v >> l;
		u--; v--;
		queries_by_u[u].emplace_back(v, l);
	}

	vector<bool> good_edge(m);
	for(int u = 0; u < n; u++) {
		vector<int> by_ev(n, -INF);
		for(int ev = 0; ev < n; ev++) {
			for(auto [v, l]: queries_by_u[u]) {
				by_ev[ev] = max(by_ev[ev], l - dist[ev][v]);
			}
		}
		for(auto [eu, ev, ew, i]: edges) {
			if(by_ev[ev] >= dist[eu][u] + ew) {
				good_edge[i] = true;
			}
		}
	}

	int ans = 0;
	for(bool x: good_edge) {
		ans += x;
	}

	cout << ans << endl;

	return 0;
}