#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define gcd __gcd
#define int long long

using namespace std;
using namespace __gnu_pbds;

const int MAXN = 600, INF = 1e9 + 1;

long long dist[MAXN][MAXN], dp[MAXN][MAXN], Q[MAXN][MAXN], good[MAXN][MAXN], is_edge[MAXN][MAXN];

main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            dist[i][j] = INF;
            Q[i][j] = 0;
        }
        dist[i][i] = 0;
    }
    for (int i = 0; i < m; i++) {
        int v, u, x;
        cin >> v >> u >> x;
        is_edge[v - 1][u - 1] = is_edge[u - 1][v - 1] = x;
        dist[v - 1][u - 1] = dist[u - 1][v - 1] = x;
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int v, u, x;
        cin >> v >> u >> x;
        Q[v - 1][u - 1] = Q[u - 1][v - 1] = x;
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                if (dist[i][k] + dist[k][j] <= Q[i][j]) {
                    dp[k][j] = max(dp[k][j], Q[i][j] - dist[i][k]);
                }
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < n; k++) {
                if (dp[i][k] >= dist[j][k] + is_edge[i][j]) {
                    good[i][j] = true;
                }
            }
        }
    }
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i + 1; j < n; j++) {
            cnt += bool(good[i][j] * is_edge[i][j]);
        }
    }
    cout << cnt << '\n';
    return 0;
}
